unit BasicObj;
{------------------------------------------------------------}
{  \   /  ==  ==|==  /\  |\    /|'/===                       }
{   \ /  |  |   |   |  | | \  / | \___                       }
{    |   |  |   |   |__| |  \/  |    |                       }
{    |    ==    |   |  | |      | \__/                       }
{                                                            }
{  \      / O /=== O  ==  |\   |                             }
{   \    /  | \___ | |  | | \  |                             }
{    \  /   |    | | |  | |  \ |  By:                        }
{     \/    | \__/ |  ==  |   \|  Dr. Yotam Madem            }
{                                                            }
{    P.G.I                                                   }
{   -------                                                  }
{   Powerfull Graphic Interface with multitasking            }
{   P.G.I(r) Copyright(c) 1998 by Y.M.S(r) -                 }
{   Yotam. Madem. Software. Corporation.                     }
{------------------------------------------------------------}
{   BASICOBJ.PAS - PGI Unit including basic system object:   }
{   TView - This object requierd for all Yotams Vision       }
{   Objects.                                                 }
{------------------------------------------------------------}

interface
 uses   BGI2, A_Mouse, YFonts,
                    Draw_Obj,
                    RBasicT;

Const
  {-----Events-----}
  evNoEvent    = 4;
  evSysCommand = evNoEvent*2;
  evCommand    = evSysCommand*2;
  evObjToObj   = evCommand*2;
  evUsrInput   = evObjToObj*2;

  {----Commands----}
  cmNoCommand   = 0;
  cmExit        = 1;
  cmOk          = 2;
  cmCancel      = 3;
  cmClose       = 4;
  cmNext        = 5;
  cmPrev        = 6;
  cmCopy        = 7;
  cmPaste       = 8;
  cmDelete      = 9;
  cmOutOfRange  = 10;
  cmOpenWindow  = 11;
  cmMoveWin     = 12;
  cmDialogMenu  = 13;
  cmNextWin     = 14;
  cmCloseButton = 15;
  cmMenuButton  = 16;
  cmMiniButton  = 17;
  cmEnd         = 18;
  cmSelectObj   = 19;

  codDialog    = 1;

Type
  MouseEvent = (RButton, LButton, None);
  TInput     = Object
                 ME    : MouseEvent;
                 ifKey : boolean;
                 Key   : char;
                 c0    : Boolean;
                 Function CheckEvent : Boolean;
               end;

  PKeyType   = ^KeyType;
  KeyType    = object
                 Key : Char;
                 c0  : boolean;
                 Procedure Init(Pkey : char; Pc0 : Boolean);
                 Function Accepted(T : TInput) : Boolean;
               end;

  TEvent   = object
                T         : TInput;
                What      : longint;
                Command   : integer;
                SenderPtr : Pointer;
             end;

  PView    = ^TView;
  TView    = Object(TGObject)
                R             : TRect;   {Main Object Rectangle}
                Active        : Boolean; {Is the object active?}
                Code          : Integer; {Object code (on events)}
                pdone         : boolean; {Inside loops}
                Selected      : Boolean; {Is this object selected by user?}
                TTr           : TRect;   {Title Rect}
                MB            : TRect;   {Menu Button}
                MinB          : TRect;   {Minimize Button}
                MaxB          : TRect;
                ClosB         : TRect;   {Close Button}
                WinTitle      : String;  {Title Str}
                TmpR          : TRect;   {Rectangle for TMP}
                SNum          : integer; {Serial Number}
                Owner         : PView;
                VP            : Boolean;
                CanBeSelected : Boolean;
                CanBePointed  : Boolean;
                SelectedByKB  : Boolean;
                constructor init(PR : TRect; PCode : integer);
                Procedure Act(var Event : TEvent);   virtual;
                Procedure SetDrawViewPort;           virtual;
                Procedure RestoreDrawViewPort;       virtual;
                Procedure Draw;                      virtual;
                Procedure TimeUpDate;                virtual;
                Procedure ShowModal;                 virtual;
                Procedure Select;                    virtual;
                Procedure UnSelect;                  virtual;
                Procedure Move(x,y : integer);       virtual;
                Procedure UsrMove;                   virtual;
                Procedure SetAreas;                  virtual;
                Procedure Clamp(P : TPoint);         virtual;
                Procedure UnClamp;                   virtual;
                Procedure OnMove;                    virtual;
                Procedure InitWithOwner;             virtual;
                destructor done;                     virtual;
             end;

Procedure InitScrSize;

implementation


Function TInput.CheckEvent : Boolean;
begin
   CheckEvent := False;
   ifKey := false;
   c0 := false;
   ME := None;
   Key := ' ';
   if KeyPressed then
   begin
      ifKey := true;
      Key := ReadKey;
      if Key = #0 then
      begin
         Key := Readkey;
         c0 := true;
      end;
      CheckEvent := True;
   end;

   if LButtonDown then
   begin
     ME := LButton;
     CheckEvent := True;
   end;
   if RButtonDown then
   begin
     ME := RButton;
     CheckEvent := True;
   end;
end;

Procedure KeyType.Init(Pkey : char; Pc0 : Boolean);
begin
   Key := PKey;
   C0  := Pc0;
end;

Function KeyType.Accepted(T : TInput) : Boolean;
begin
   Accepted := False;
   if not t.ifkey then Exit;
   if (t.c0 = c0) and (t.key = key) then
     Accepted := True
    else
     Accepted := False;
end;

Constructor TView.init(PR : TRect; PCode : integer);
begin
   R := PR;
   Code := PCode;
   SetAreas;
   Owner := Nil;
end;

Procedure TView.SetAreas;
var
 W : WinButtons;
begin
   BWindowInitButtons(R,W);
   TTr   := W.Title;
   Mb    := W.MenuB;
   MinB  := W.MiniB;
   ClosB := W.ClosB;
end;

Procedure TView.Act(var Event : TEvent);
begin
end;

Procedure TView.RestoreDrawViewPort;
begin
   if VP then
      SetViewPort(ScrX,ScrY,ScrX1,ScrY1,True);
end;

Procedure TView.SetDrawViewPort;
begin
   VP := False;
   if (VPx1 = ScrX) and (VPy1 = ScrY) and
      (VPx2 = ScrX1) and (VPy2 = ScrY1) then
      begin
         if Owner = nil then
           SetViewPort(r.x,r.y,r.x1,r.y1,True)
          else
           SetViewPort(Owner^.r.x,Owner^.r.y,Owner^.r.x1,Owner^.r.y1,True);
         VP := True;
      end;
end;

Procedure TView.Draw;
var
 tr : TRect;
begin
   BWindow(r,WinTitle);
   Tr.Assign(r.x+5,r.y+28,r.x1-5,r.y1-5);
   SetFillStyle(1,3);
   ColorPannel(Tr, False, 7);
   if Not Active then
    BWindowTitle(r,WinTitle,False);
end;

Procedure TView.TimeUpDate;
begin
end;

Procedure TView.ShowModal;
begin
end;

Procedure TView.Select;
begin
   Active := True;
   Selected := True;
end;

Procedure TView.UnSelect;
begin
   Active := False;
   Selected := False;
end;

Procedure TView.UsrMove;
var
 mx, my : integer;
 hx, hy : integer;
 wdone  : boolean;
 Bdn    : boolean;
 hmx,
 hmy    : integer;

Procedure DoRect;
begin
   SetLineStyle(4,OSStyle,0);
   Rectangle(mx-1,my-1,mx+hx+1,my+hy+1);
{   Rectangle(mx-2,my-2,mx+hx+2,my+hy+2);
   Rectangle(mx-3,my-3,mx+hx+3,my+hy+3);}
   SetLineStyle(0,0,0);
end;

begin
   hx := r.x1-r.x;
   hy := r.y1-r.y;
   mx := r.x;
   my := r.y;
   Hmx := GetMouseX-mx;
   Hmy := GetMouseY-my;
   HideMouse;
   SetMouseCursor(mx,my);
   SetColor(15);
   SetWriteMode(XORPut);
   DoRect;
   wdone := false;
   if A_mouse.ButtonDown then Bdn := true
  else
   Bdn := false;
   Repeat
      if (GetMouseX <> mx) or (GetMouseY <> my) then
       if ((GetMouseX+hmx) < GetMaxX) and ((GetMouseY+hmy) < GetMaxY) then
       begin
          DoRect;
          mx := GetMouseX;
          my := GetMouseY;
          DoRect;
       end
      else
       begin
          if ((GetMouseX+hmx) >= GetMaxX) then
          begin
             SetMouseCursor(GetMaxX-hmx-1, my);
          end;

          if ((GetMouseY+hmy) >= GetMaxY) then
          begin
             SetMouseCursor(mx, GetMaxY-hmy-1);
          end;
       end;

      if Bdn then
       if A_mouse.ButtonUp then
        wdone := true;

      if not Bdn then
       if A_mouse.ButtonDown then
        wdone := true;
      ClearKeyBuff;
      DoSystem;
   until wDone;
   DoRect;
   SetLineStyle(0,0,0);
   SetWriteMode(NormalPut);
   SetMouseCursor(Hmx+mx,Hmy+my);
   Move(mx-r.x,my-r.y);
   BClick := True;
   ShowMouse;
end;

Procedure TView.OnMove;
begin
end;

Procedure TView.Move(x,y : integer);
begin
   R.Move(x,y);
   SetAreas;
end;

Procedure TView.Clamp(P : TPoint);
begin
   TmpR := R;
   if Owner <> nil then
     R.Move(Owner^.R.x,Owner^.R.y)
    else
     R.Move(-P.x,-P.y);
   SetAreas;
end;

Procedure TView.InitWithOwner;
begin
end;

Procedure TView.UnClamp;
begin
   R := TmpR;
   SetAreas;
end;

Destructor TView.Done;
begin
end;

Procedure InitScrSize;
begin
   ScrX := 0;
   ScrY := 0;
   ScrX1 := GetMaxX;
   ScrY1 := GetMaxY;
end;

end.
