unit BGI2;

interface

uses Graph, SVGA256;
{$F-}

Const
   OSStyle = 43690;

var
 CurrWriteMode : integer;
 VPx1, VPy1, VPx2, VPy2 : Word;
 ScrX  : integer;
 ScrY  : integer;
 ScrX1 : integer;
 ScrY1 : integer;


Procedure Line(x,y,x1,y1 : integer);
Procedure SetViewPort(x,y,x1,y1 : integer; clip : boolean);
Procedure Bar(x,y,x1,y1 : integer);
Procedure Rectangle(x,y,x1,y1 : integer);
Procedure PutPixel(x,y : integer; c : byte);
Procedure SetWriteMode(WM : integer);
Procedure SetColor(c : byte);
Procedure MoveTo(x,y : integer);
Procedure SetFillStyle(x,y : integer);
Procedure SetLineStyle(LineStyle: Word; Pattern: Word; Thickness: Word);
Procedure CloseGraph;
Procedure InitGraph;
function GetColor : byte;
function GetMaxY : integer;
function GetMaxX : integer;
function GetY : integer;
function GetX : integer;
Procedure Pal(col,r,g,b:byte);
Procedure PutImage(x,y : integer; var Buff; attr : integer);
Procedure GetImage(x1,y1,x2,y2 : integer; var Buff);
Function ImageSize(x1,y1,x2,y2 : integer) : word;


Const
  XORPut    = Graph.XORPut;
  NormalPut = Graph.NormalPut;

implementation

var
 GDriver, GMode : integer;

Procedure Line(x,y,x1,y1 : integer);
begin
   Graph.Line(x,y,x1,y1);
end;

Procedure SetViewPort(x,y,x1,y1 : integer; clip : boolean);
begin
   if x1 > ScrX1 then x1 := ScrX1;
   if x < 0 then x := 0;
   if y1 > ScrY1 then y1 := ScrY1;
   if y < 0 then y := 0;
   Graph.SetViewPort(x,y,x1,y1,clip);
   VPx1 := x;
   VPy1 := y;
   VPx2 := x1;
   VPy2 := y1;
end;

Procedure Bar(x,y,x1,y1 : integer);
begin
   Graph.Bar(x,y,x1,y1);
end;

Procedure Rectangle(x,y,x1,y1 : integer);
begin
   Graph.Rectangle(x,y,x1,y1);
end;

Procedure PutPixel(x,y : integer; c : byte);
begin
{   if c = 15 then
    c := 0
   else
    if c = 0 then c := 15;}

   Graph.PutPixel(x,y,c);
end;

Procedure SetWriteMode(WM : integer);
begin
   CurrWriteMode := WM;
   Graph.SetWriteMode(WM);
end;

Procedure SetColor(c : byte);
begin
{   if c = 15 then
    c := 0
   else
    if c = 0 then c := 15;}
   Graph.SetColor(c);
end;

Procedure MoveTo(x,y : integer);
begin
   Graph.MoveTo(x,y);
end;

Procedure SetFillStyle(x,y : integer);
begin
{   if y = 15 then
    y := 0
   else
    if y = 0 then y := 15;}

   Graph.SetFillStyle(x,y);
end;

Procedure CloseGraph;
begin
   Graph.CloseGraph;
end;

Function ImageSize(x1,y1,x2,y2 : integer) : word;
begin
   ImageSize := Graph.ImageSize(x1,y1,x2,y2);
end;

Procedure GetImage(x1,y1,x2,y2 : integer; var Buff);
begin
   Graph.GetImage(x1,y1,x2,y2,Buff);
end;

Procedure PutImage(x,y : integer; var Buff; attr : integer);
var
 V : ViewPortType;
begin
{   GetViewSettings(V);
   if (x <= (v.x2-v.x1)) and (x >= 0) and
      (x <= (v.y2-v.y1)) and (y >= 0) then}
        Graph.PutImage(x,y,Buff,Attr);
end;

Procedure InitGraph;
begin
   Graph.InitGraph(GDriver, GMode, '');
{    SetGrMode(5);
    InitGraphics;

{   InitSVGA256;
   SetGraphMode(2);}
end;

function GetColor : byte;
var
 c : integer;
begin
   C := Graph.GetColor;
{   if c = 15 then
    c := 0
   else
    if c = 0 then c := 15;}

   GetColor := c;
end;

function GetMaxY : integer;
begin
   GetMaxY := Graph.GetMaxY;
end;

function GetMaxX : integer;
begin
   GetMaxX := Graph.GetMaxX;
end;

function GetY : integer;
begin
   GetY := Graph.GetY;
end;

function GetX : integer;
begin
   GetX := Graph.GetX;
end;

Procedure SetLineStyle(LineStyle: Word; Pattern: Word; Thickness: Word);
begin
   Graph.SetLineStyle(LineStyle, Pattern, Thickness);
end;

Procedure InstallBGIDriv;
begin
   GDriver := InstallUserDriver('EGAVGA', nil);
   GMode := 2;
end;

Procedure Pal(Col,R,G,B : Byte);
begin
  if col > 7 then Inc(Col,48);
  port[$3C8]:=Col;
  port[$3C9]:=r;
  port[$3C9]:=g;
  port[$3C9]:=b;
end;


begin
   CurrWriteMode := NormalPut;
end.
