unit Desktop;

interface

 uses  BGI2, A_Mouse, BasicObj, SysObj, RBasicT, Draw_Obj;

var
 Mac : Boolean;

Type
 PDesktop = ^TDesktop;
 TDesktop = Object(TGObject)
              Forms    : Array[1..100] of PForm;
              WinCount : integer;
              PDone    : Boolean;
              PRun     : Boolean;
              F        : PForm;
              R        : TRect;
              Rdrw     : Boolean;
              Saman    : integer;
              UpDn     : Boolean;
              Constructor init;
              Procedure TimeUpDate;                             virtual;
              Procedure Draw;                                   virtual;
              Procedure InsertForm(PF : PForm);                 virtual;
              Procedure Run;                                    virtual;
              Procedure Restore(PR : TRect);                    virtual;
              Procedure RestoreWall;                            virtual;
              Procedure OutOfRange;                             virtual;
              Procedure DoUsrEv(var Event : TEvent);            virtual;
              Procedure SetWin(i : integer);                    virtual;
              Procedure SetWinPtr(var Obj : Pointer);           virtual;
              Procedure ChUsrEv(var Event : TEvent);            virtual;
              Procedure SetWindowsNums;                         virtual;
              Function  ExecuteDialog(var D : PForm; Sound : boolean)
                                                     : integer; virtual;
              Procedure DoDialogUsrEv(var Event : TEvent; var
                                                    D : PForm); virtual;
              Procedure ChDialogUsrEv(var Event : TEvent; var
                                                    D : PForm); virtual;
              Destructor done;                                  virtual;
            end;

 TApp     = Object (TDesktop)

            end;

implementation

Constructor TDesktop.init;
begin
   MDesk := @Self;
   WinCount := 0;
   PRun  := False;
   initGraph;
   if Mac then
     MacPal;
{   PAl(0,63,63,63);
   Pal(15,0,0,0);}
   Randomize;
   InitScrSize;
   SetFillStyle(1,BkColor);
   Bar(0,0,GetMaxX,GetMaxY);
   Pal(7,42,42,42);
   initmouse;
   showmouse;
   SetViewPort(ScrX,ScrY,ScrX1,ScrY1,True);

   SetMouseSensitivity(50,50);
end;

Procedure TDesktop.Draw;
var
 i : integer;
begin
   if WinCount < 1 then Exit;
   for i := 1 to WinCount do
    Forms[I]^.Draw;
end;

Procedure TDesktop.InsertForm(PF : PForm);
begin
   if WinCount >= 100 then exit;
   if not PRun then
   begin
      Inc(WinCount);
      Forms[WinCount] := PF;
   end
  else
   begin
      Forms[WinCount]^.UnSelect;
      Forms[WinCount]^.Draw;
      Inc(WinCount);
      Forms[WinCount] := PF;
      Forms[WinCount]^.Select;
      Rdrw := True;
   end;
end;

Procedure TDesktop.RestoreWall;
begin
   SetFillStyle(1,BkColor);
   Bar(0,0,GetMaxX,GetMaxY);
end;

Procedure TDesktop.Restore(PR : TRect);
var
 i : integer;
 P : TPoint;
begin
   if pr.x1 = 0 then exit;
   if pr.x > getmaxx then exit;
   if pr.y > getmaxy then exit;

   if pr.x1 > getmaxx then
      pr.x1 := getmaxx;
   if pr.y1 > getmaxy then
      pr.y1 := getmaxy;
   if pr.x < 0 then
      pr.x := 0;
   if pr.y < 0 then
      pr.y := 0;

   HideMouse;
   Restoring := True;
   SetViewPort(pr.x,pr.y,pr.x1,pr.y1,True);
   RestoreWall;
   P.x := pr.x;
   P.y := pr.y;
   for i := 1 to WinCount do
   begin
      Forms[i]^.Clamp(P);
      Forms[i]^.Draw;
      Forms[i]^.UnClamp;
   end;
   SetViewPort(ScrX,ScrY,ScrX1,ScrY1,True);
   Restoring := False;
   ShowMouse;
end;

Procedure TDesktop.SetWindowsNums;
var
 i : integer;
begin
   if WinCount < 1 then Exit;
   for i := 1 to WinCount do
     Forms[i]^.WinNum := i;
end;

Procedure TDesktop.SetWinPtr(var Obj : Pointer);
var
 i : integer;
begin
   i := PForm(Obj)^.WinNum;
   if (i >= 1) and (i < WinCount) then
     SetWin(i);
end;

Procedure TDesktop.SetWin(i : integer);
var
 j : integer;
begin
   Forms[WinCount]^.UnSelect;
   Forms[WinCount]^.DrawTitle(False);
   F := Forms[i];
   for j := i to WinCount-1 do
   begin
      Forms[j] := Forms[j+1];
   end;
   Forms[WinCount] := F;
   SetWindowsNums;
   Forms[WinCount]^.Select;
   Rdrw := True;
end;

Procedure TDesktop.OutOfRange;
var
 i, j : integer;
begin
   for i := WinCount downto 1 do
   begin
      if (Forms[i]^.R.ClickedOnMe) and (Forms[i]^.r.MouseOnMe) then
      begin
         SetWin(I);
         Break;
      end;
   end;
end;

Procedure TDesktop.ChUsrEv(var Event : TEvent);
begin
   if Event.T.ifKey then

      Case Event.T.Key of

         #64{F6}   : if Event.T.c0 then
                     begin
                        Event.What := evSysCommand;
                        Event.Command := cmNextWin;
                        Exit;
                     end;
         #45{Alt-X}: if Event.T.c0 then
                     begin
                        Event.What := evCommand;
                        Event.Command := cmExit;
                        Exit;
                     end;
      end;

   if (Event.T.ME <> none) and (WinCount > 0) then
   if (not ((Forms[WinCount]^.R.ClickedOnMe)or
           (Forms[WinCount]^.R.MouseOnMe))) then
   begin
      Event.What := evSysCommand;
      Event.Command := cmOutOfRange;
      Exit;
   end;

end;

Procedure TDesktop.ChDialogUsrEv(var Event : TEvent; var D : PForm);
begin
   if Event.T.ifKey then

      Case Event.T.Key of

          #64 {F6} : if Event.T.c0 then
                     begin
                        Event.What := evSysCommand;
                        Event.Command := cmNextWin;
                        Exit;
                     end;
          #45      : if Event.T.c0 then
                     begin
                        Event.What := evCommand;
                        Event.Command := cmExit;
                        Exit;
                     end;
      end;

   if (Event.T.ME <> none) and (WinCount > 0) then
   if (not ((D^.R.ClickedOnMe)or
           (D^.R.MouseOnMe))) then
   begin
      Event.What := evSysCommand;
      Event.Command := cmOutOfRange;
      Exit;
   end;

end;

Procedure TDesktop.DoUsrEv(var Event : TEvent);
var
 i,j : integer;
 tr1,
 tr2 : TRect;
begin
   if Event.What = evCommand then
   case Event.Command of

           cmClose       : begin
                              Event.What := evSysCommand;
                           end;

           cmExit        : begin
                              PDone := true;
                              Event.Command := cmNoCommand;
                           end;

           cmOpenWindow  : begin
                              Event.Command := cmNoCommand;
                           end;



   end;

   if Event.what = evSysCommand then
   Case Event.Command of

           cmClose       : if wincount > 0 then
                           begin
                              if Saman = WinCount then
                                Dec(Saman);
                              Dispose(Forms[WinCount], done);
                              Dec(WinCount);
                              HideMouse;
                              Restore(R);
                              ShowMouse;
                              if WinCount > 0 then
                              begin
                                Forms[WinCount]^.Select;
                                Forms[WinCount]^.DrawTitle(True);
                              end;
                              Event.Command := cmNoCommand;
                           end;

           cmOutOfRange  : if wincount > 0 then
                           begin
                              OutOfRange;
                              Event.Command := cmNoCommand;
                           end;

           cmMoveWin     : if wincount > 0 then
                           begin
                              Forms[WinCount]^.UsrMove;
                              if (R.X <> Forms[WinCount]^.r.x) or
                                 (R.Y <> Forms[WinCount]^.r.y) then
                                 begin
                                    GetRestoreArea(R,Forms[WinCount]^.r,
                                                   tr1, tr2);
                                    Restore(tr1);
                                    Restore(tr2);
                                    Forms[WinCount]^.OnMove;
                                    R := Forms[WinCount]^.r;
                                    Rdrw := true;
                                 end;
                              Event.Command := cmNoCommand;
                           end;

           cmNextWin     : begin
                             if WinCount <= 1 then Exit;
                             if Saman > 1 then
                              dec(Saman)
                             else
                              Saman := WinCount-1;
                             SetWin(Saman);
                             Event.Command := cmNoCommand;
                           end;

      end;
end;

Procedure TDesktop.DoDialogUsrEv(var Event : TEvent; var D : PForm);
var
 i,j : integer;
 tr1,
 tr2 : TRect;
begin
   if Event.What = evCommand then
   case Event.Command of

           cmClose       : begin
                              Event.What := evSysCommand;
                           end;

           cmExit        : begin
                              Event.What := evSysCommand;
                           end;

           cmOpenWindow  : begin
                              Event.Command := cmNoCommand;
                           end;



   end;

   if Event.what = evSysCommand then
   Case Event.Command of

           cmClose       : begin
                              Dispose(D, Done);
                              HideMouse;
                              Restore(R);
                              ShowMouse;
                              PDone := True;
                              Event.Command := cmNoCommand;
                           end;

           cmExit        : begin
                              Dispose(D, Done);
                              HideMouse;
                              Restore(R);
                              ShowMouse;
                              PDone := True;
                           end;

           cmOutOfRange  : begin
                              Beep;
                              Event.Command := cmNoCommand;
                           end;

           cmMoveWin     : begin
                              D^.UsrMove;
                              if (R.X <> D^.r.x) or
                                 (R.Y <> D^.r.y) then
                                 begin
                                    GetRestoreArea(R,D^.r,
                                                   tr1, tr2);
                                    Restore(tr1);
                                    Restore(tr2);
                                    D^.OnMove;
                                    R := D^.r;
                                    RDrw := True;
                                 end;
                              Event.Command := cmNoCommand;
                           end;

           cmNextWin     : begin
                              Beep;
                           end;

      end;
end;


Procedure TDesktop.TimeUpDate;
begin
   if WinCount > 0 then
     Forms[WinCount]^.TimeUpDate;
end;

Procedure TDesktop.Run;
var
 i     : integer;
 Event : TEvent;
begin
   InitTimer;
   PDone := false;
   PRun  := True;
   Saman := WinCount;
   UpDn  := False; {Down}
   if WinCount > 0 then
    for i := 1 to WinCount do
     Forms[i]^.Active := False;
   SetWindowsNums;
   if WinCount > 0 then
     Forms[WinCount]^.Select;
   Draw;
   Rdrw := False;
   Repeat
      Event.What := evNoEvent;
      if WinCount > 0 then
      begin
         R  := Forms[WinCount]^.R;
         Forms[WinCount]^.Active := true;
         if Rdrw then
           Forms[WinCount]^.Draw;
         Rdrw := False;
      end;
      repeat
         TimeUpDate;
      until Event.T.CheckEvent;
      ChUsrEv(Event);
      DoUsrEv(Event);
      if WinCount > 0 then
        if Event.What = evNoEvent then
        begin
           Event.What := evUsrInput;
           Forms[WinCount]^.Act(Event);
           DoUsrEv(Event);
        end;
   Until PDone;
   KillTimer;
end;

Function TDesktop.ExecuteDialog(var D : PForm; Sound : boolean) : Integer;
var
 i     : integer;
 Event : TEvent;
 tmpr  : TRect;
 loop  : integer;
 flip  : word;
begin
{   if (D^.R.x1-D^.R.x) > (D^.R.y1-D^.R.y) then
   begin
      tmpr.y := D^.R.y+((D^.R.y1-D^.R.y) div 2);
      tmpr.y1 := tmpr.y;
      tmpr.x := D^.R.x + (D^.R.y1-D^.R.y) div 2;
      tmpr.x1 := D^.R.x1 - (D^.R.y1-D^.R.y) div 2;
      loop := (D^.R.y1-D^.R.y) div 2;
   end
  else
   begin
      tmpr.x := D^.R.x+((D^.R.x1-D^.R.x) div 2);
      tmpr.x1 := tmpr.x;
      tmpr.y := D^.R.y + (D^.R.x1-D^.R.x);
      tmpr.y1 := D^.R.y1 - (D^.R.x1-D^.R.x);
      loop := (D^.R.x1-D^.R.x);
   end;
   setfillstyle(1,8);
   flip := 100;
   if sound then
     music.play('>>C1G1>>C1');
   for i := 1 to loop div 5 do
   begin
      bar(tmpr.x,tmpr.y,tmpr.x1,tmpr.y1);
      delay(7);
      dec(tmpr.x,5);
      inc(tmpr.x1,5);
      dec(tmpr.y,5);
      inc(tmpr.y1,5);
   end;                                         }
   Forms[WinCount]^.UnSelect;
   Forms[WinCount]^.DrawTitle(False);
   D^.Select;
   D^.Draw;
   Rdrw := False;
   Repeat
      Event.What := evNoEvent;
      R  := D^.R;
      D^.Active := true;
      if Rdrw then
         D^.Draw;
       Rdrw := False;
      repeat
         TimeUpDate;
         D^.TimeUpDate;
      until Event.T.CheckEvent;
      ChDialogUsrEv(Event,D);
      DoDialogUsrEv(Event,D);
      if Event.What = evNoEvent then
      begin
         Event.What := evUsrInput;
         D^.Act(Event);
         DoDialogUsrEv(Event,D);
      end;
   Until PDone;
   if Event.Command <> cmExit then
     PDone := False;
   Forms[WinCount]^.Select;
   Forms[WinCount]^.DrawTitle(True);
end;

Destructor TDesktop.done;
var
 i : integer;
begin
   if WinCount > 0 then
     for i := 1 to WinCount do
       Dispose(Forms[i],Done);
   CloseGraph;
end;

begin
   Mac := False;
end.
