uses Crt, Graph, RBasicT, YFonts;
type
  Btype = Array[1..110] of byte;
Const
  CloseB  : Array[1..3] of BType =(
            (
            $0D,$00,$0C,$00,$80,$0C,$80,$0C,$80,$0C,
            $80,$0C,$BF,$FC,$80,$0C,$80,$0C,$BF,$FC,
            $BF,$DC,$9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,
            $9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,$9F,$CC,
            $9F,$CC,$A0,$1C,$BF,$DC,$9F,$CC,$9F,$CC,
            $A0,$1C,$BF,$DC,$9F,$CC,$9F,$CC,$A0,$1C,
            $BF,$DC,$9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,
            $9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,$9F,$CC,
            $9F,$CC,$A0,$1C,$BF,$DC,$9F,$CC,$9F,$CC,
            $A0,$1C,$A0,$1C,$80,$0C,$80,$0C,$A0,$1C,
            $BF,$FC,$80,$0C,$80,$0C,$BF,$FC,$00,$00
            ),(
            $0D,$00,$0C,$00,$80,$0C,$80,$0C,$80,$0C,
            $80,$0C,$BF,$EC,$80,$0C,$80,$0C,$9D,$CC,
            $BF,$EC,$80,$0C,$80,$0C,$AD,$AC,$BF,$EC,
            $80,$0C,$80,$0C,$B5,$6C,$BF,$EC,$80,$0C,
            $80,$0C,$BF,$EC,$BF,$EC,$80,$0C,$80,$0C,
            $BF,$EC,$FF,$FC,$80,$0C,$80,$0C,$87,$0C,
            $BF,$EC,$80,$0C,$80,$0C,$BF,$EC,$BF,$EC,
            $80,$0C,$80,$0C,$B7,$6C,$BF,$EC,$80,$0C,
            $80,$0C,$AD,$AC,$BF,$EC,$80,$0C,$80,$0C,
            $AD,$AC,$BF,$EC,$80,$0C,$80,$0C,$9D,$CC,
            $80,$0C,$80,$0C,$80,$0C,$80,$0C,$00,$00
            ),(
            $0D,$00,$0C,$00,$80,$0C,$80,$0C,$80,$0C,
            $80,$0C,$BF,$FC,$80,$0C,$80,$0C,$BF,$FC,
            $BD,$DC,$9D,$CC,$9D,$CC,$A0,$1C,$BD,$DC,
            $9D,$CC,$9D,$CC,$A0,$1C,$BD,$DC,$9D,$CC,
            $9D,$CC,$A0,$1C,$BD,$DC,$9D,$CC,$9D,$CC,
            $A0,$1C,$BD,$DC,$9D,$CC,$9D,$CC,$A0,$1C,
            $A1,$DC,$81,$CC,$81,$CC,$A0,$1C,$BF,$DC,
            $9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,$9F,$CC,
            $9F,$CC,$A0,$1C,$BF,$DC,$9F,$CC,$9F,$CC,
            $A0,$1C,$A0,$1C,$80,$0C,$80,$0C,$A0,$1C,
            $BF,$FC,$80,$0C,$80,$0C,$BF,$FC,$8A,$8C
            ));


Type
  MacWindow = object
                Title   : string;
                Bounds  : TRect;
                FrstDrw : boolean;
                P       : Pointer;
                SP      : Word;
                ttx     : integer;
                Constructor Init;
                Procedure Assign(px,py,px1,py1 : integer; ptitle : string);
                Procedure Draw;
              end;

Constructor MacWindow.Init;
begin
   P := Nil;
   SP := 0;
end;

Procedure MacWindow.Assign(px,py,px1,py1 : integer; ptitle : string);
begin
   FrstDrw := True;
   Bounds.Assign(px,py,px1,py1);
   Title := PTitle;
   if P <> nil then
     FreeMem(P,SP);
end;

Procedure MacWindow.Draw;
var
 x,y,x1,y1 : integer;
 i,tx,tx1, middle : integer;

begin
   x  := Bounds.x;  y  := Bounds.y;
   x1 := Bounds.x1; y1 := Bounds.y1;
   SetColor(0);
   Rectangle(x,y,x1-2,y1);
   Line(x,y1-1,x1,y1-1);
   Line(x1-1,y+2,x1-1,y1);
   Line(x1,y+2,x1,y1);
   SetFillStyle(1,15);
   Bar(x+1,y+21,x1-3,y1-3);

   SetFillStyle(1,15);
   Bar(x+1,y,x1-3,y+18);
   SetColor(9);
   Rectangle(x+1,y,x1-3,y+18);
   SetColor(1);
   Line(x+1,y+18,x1-3,y+18);
   Line(x1-3,y+18,x1-3,y);
   SetColor(8);
   for i := 1 to 7 do
     Line(x+3,y+i*2+1,x1-5,y+i*2+1);

   if FrstDrw then
   begin
      FrstDrw := False;
      Middle := (x+1)+(((x1-2)-(x+1))div 2);
      tx := (Middle - (YTextWidth(Title) div 2))-5;
      tx1 := tx+YTextWidth(Title)+10;
      SetFillStyle(1,15);
      SetColor(0);
      Bar(tx,y+2,tx1,y+16);
      MoveTo(tx+5,y+4);
      YOutText(Title);

      SP :=ImageSize(tx,y+2,tx1,y+16);
      GetMem(P,SP);
      GetImage(tx,y+2,tx1,y+16,P^);
      ttx := tx;
   end
  else
   begin
      PutImage(ttx,y+2,P^,0);
   end;

   PutImage(x+9,y+3,CloseB[1],0);
   PutImage(x1-23,y+3,CloseB[3],0);
end;


Procedure Pal(Col,R,G,B : Byte);
begin
  if col > 7 then Inc(Col,48);
  port[$3C8]:=Col;
  port[$3C9]:=r;
  port[$3C9]:=g;
  port[$3C9]:=b;
end;

Procedure MacPal;
begin
   Pal(3,0,32,32);
   Pal(8,24,24,16);
   Pal(1,40,40,63);
   Pal(9,48,48,63);
   pal(14,40,40,32);
end;

var
 Gd, Gm,i, x,y : integer;
 M : MacWindow;
begin
   InitGraph(Gd, Gm, '');
   LoadYTF('Mac.ytf');
   MacPal;
   setfillstyle(1,3);
   bar(0,0,Getmaxx,Getmaxy);
   M.Init;
   M.Assign(100,100,400,350,'Applications');
   M.Draw;
   repeat
   until keypressed;
   readkey;
   CloseGraph;
end.