Unit RBasicT;

{------------------------------------------------------------}
{  \   /  ==  ==|==  /\  |\    /|'/===                       }
{   \ /  |  |   |   |  | | \  / | \___                       }
{    |   |  |   |   |__| |  \/  |    |                       }
{    |    ==    |   |  | |      | \__/                       }
{                                                            }
{  \      / O /=== O  ==  |\   |                             }
{   \    /  | \___ | |  | | \  |                             }
{    \  /   |    | | |  | |  \ |  By:                        }
{     \/    | \__/ |  ==  |   \|  Dr. Yotam Madem            }
{                                                            }
{    P.G.I                                                   }
{   -------                                                  }
{   Powerfull Graphic Interface with multitasking            }
{   P.G.I(r) Copyright(c) 1998 by Y.M.S(r) -                 }
{   Yotam. Madem. Software. Corporation.                     }
{------------------------------------------------------------}
{   RBASICT.PAS - A PGI Unit includes system basic           }
{   procedures for YV.                                       }
{------------------------------------------------------------}


interface

uses A_Mouse, Dos, BGI2, Music_u;
type
  PBool = ^Boolean;
var
 DCTime  : longint; {Double Click time}
 LastMx,
 LastMy  : integer;
 BDown   : Boolean;
 SaveInt1: Pointer;
 BClick  : Boolean;
 CallSys : Boolean;

 MenuBkColor    : Byte;
 MenuSColor     : Byte;
 MenuTColor     : Byte;
 MenuTSColor    : Byte;
 MenuItmHeight  : Byte;
 MenuItmLHeight : Byte;
 SysProcPtr     : Pointer;
 Shift          : Boolean;
 Hold           : Boolean;
 Music          : MPlayer;
 MouseSttPtrs   : Array[1..1000] of PBool;
 MCount         : integer;
 Restoring      : boolean;

Type
  String80       = String[80];
  String256      = String[255];
  DosFileNameStr = String[12];
  PString        = ^String;


  TRect    = Object
               x,y,x1,y1 : integer;
               Procedure Assign(px,py,px1,py1 : integer);
               Procedure Move(Px,Py : integer);
               Procedure MoveByR(R : TRect);
               Procedure Bar(Color : Byte);
               Procedure Rectangle(Color : Byte);
               Function  MouseOnMe : Boolean;
               Function  ClickedOnMe : Boolean;
               Function  InMe(px,py : integer) : Boolean;
               Function  GetMiddleX : integer;
               Function  GetMiddleY : integer;
               Function  GetXDiff   : integer;
               Function  GetYDiff   : integer;
             end;

  TPoint   = Object
               x,y : integer;
               Function GetDifference : integer;
             end;

Const
  BkColor      = 3;
  WinFaceColor = 7;
  ButtonOn     = True;
  ButtonOff    = False;

  LowerCaseKeySet : String256 = '`1234567890-=\qwertyuiop[]asdfghjkl;''zxcvbnm,./ ';
  UpperCaseKeySet : String256 = '~!@#$%^&*()_+|QWERTYUIOP{}ASDFGHJKL:"ZXCVBNM<>? ';
  CapsLockKeySet  : String256 = '`1234567890-=\QWERTYUIOP[]ASDFGHJKL;''ZXCVBNM,./ ';
  NormalKeys      : String256 = '`1234567890-=\qwertyuiop[]asdfghjkl;''zxcvbnm,./ '+
                                '~!@#$%^&*()_+|QWERTYUIOP{}ASDFGHJKL:"ZXCVBNM<>?';
  NNormKeys       : String256 = '0123456789abcdefghijklmnopqrstuvwxyz'+
                                'ABCDEFGHIJKLMNOPQRSTUVWXYZ./\?(),:! ';


Type
  WinButtons = Object
                 Title : TRect;
                 MenuB : TRect;
                 MiniB : TRect;
                 ClosB : TRect;
               end;

  PGObject    = ^TGObject;
  TGObject    = Object
                  ObjType : integer;
                  Constructor Init;
                  Procedure TimeUpDate; virtual;
                  Destructor done; virtual;
               end;

Procedure TimerHandler; interrupt;
Procedure InitTimer;
Procedure KillTimer;
Procedure ClearKeyBuff;
Procedure DoSystem;
Procedure Delay(i : integer);
Procedure Beep;
Function  ReadKey : Char;
Function  KeyPressed : Boolean;
Function  ClearNum(Num : LongInt) : String;
Procedure GetRestoreArea(r1, r2 : TRect; var r3, r4 : TRect);
Procedure CheckShift;
Procedure InsertMSP(B : PBool);
Procedure Sound(freq : word);
Procedure NoSound;

var
 MDesk : PGObject;

implementation

uses Crt;
{$F-}

Procedure GetRestoreArea(r1, r2 : TRect; var r3, r4 : TRect);
var
 Mode : byte;
begin
   if (r1.inme(r2.x,r2.y)) then
    Mode := 1
   else
    if (r1.inme(r2.x1,r2.y1)) then
     Mode := 2
    else
     if (r1.inme(r2.x,r2.y1)) then
      Mode := 3
     else
      if (r1.inme(r2.x1,r2.y)) then
       Mode := 4
      else
       Mode := 0;

   if (r1.x = r2.x) and (r1.x1 = r2.x1) then
   begin
      if (r1.y < r2.y) then
        Mode := 5
       else
        if (r1.y > r2.y) then
         Mode := 6
        else
         if (r1.y = r2.y) then
          Mode := 7;

   end;

   Case Mode of

        0 : begin
               r3 := r1;
               r4.Assign(0,0,0,0);
            end;

        1 : begin
               r3.x  := r1.x;
               r3.x1 := r2.x;
               r3.y  := r2.y;
               r3.y1 := r1.y1;
               r4.x  := r1.x;
               r4.y  := r1.y;
               r4.x1 := r1.x1;
               r4.y1 := r2.y;
            end;

        2 : begin
               r3.x := r1.x;
               r3.x1 := r2.x1;
               r3.y := r2.y1;
               r3.y1 := r1.y1;
               r4.x := r2.x1;
               r4.y := r1.y;
               r4.x1 := r1.x1;
               r4.y1 := r1.y1;
            end;

        3 : begin
               r3.x := r1.x;
               r3.x1 := r2.x;
               r3.y := r1.y;
               r3.y1 := r2.y1;
               r4.x := r1.x;
               r4.y := r2.y1;
               r4.x1 := r1.x1;
               r4.y1 := r1.y1;
            end;

        4 : begin
               r3.x := r1.x;
               r3.x1 := r1.x1;
               r3.y := r1.y;
               r3.y1 := r2.y;
               r4.x := r2.x1;
               r4.y := r2.y;
               r4.x1 := r1.x1;
               r4.y1 := r1.y1;
            end;

        5 : begin
               r3.x := r1.x;
               r3.y := r1.y;
               r3.x1 := r1.x1;
               r3.y1 := r2.y;
               r4.Assign(0,0,0,0);
            end;

        6 : begin
               r3.x := r1.x;
               r3.y := r2.y1;
               r3.x1 := r1.x1;
               r3.y1 := r1.y1;
               r4.Assign(0,0,0,0);
            end;

        7 : begin
               r3.Assign(0,0,0,0);
               r4.Assign(0,0,0,0);
            end;

   end;
end;

Function ReadKey : Char;
begin
   ReadKey := Crt.ReadKey;
end;

Procedure Sound(freq : word);
begin
   Crt.Sound(freq);
end;

Procedure NoSound;
begin
   Crt.NoSound;
end;

Function KeyPressed : Boolean;
begin
   KeyPressed := Crt.KeyPressed;
end;

Function TPoint.GetDifference : integer;
begin
   if y > x then
     GetDifference := y-x
    else
     if x > y then
       GetDifference := y-x
      else
       if x = y then
         GetDifference := 0;
end;

Function ClearNum(Num : LongInt) : String;
var
 S : String;
 C, J, I : Byte;
Begin
   Str(Num, S);
   if Length(S) > 3 then
   Begin
      C := 1;
      J := Length(S);
      for I := 1 to Length(S) do
      Begin
         Inc(C);
         J := J -1;
         if (C = 3) and (J > 1) then
         Begin
            Insert(',',S,J);
            C := 0;
         End;
      End;
   End;
   ClearNum := S;
End;

Procedure Delay(i : integer);
begin
   Crt.Delay(i);
end;

Procedure Beep;
begin
   Sound(600);
   Delay(100);
   NoSound;
end;

Procedure DoSystem;
begin
   MDesk^.TimeUpDate;
end;

Procedure MouseHandler; interrupt;
begin
end;

Procedure TimerHandler;
var
 i : integer;
begin
   Inc(DCTime);
   if (ButtonDown) and (not BDown) then
   begin
      BDown := True;
      LastMx := GetMouseX;
      LastMy := GetMouseY;
   end;

   if (ButtonUp) and (BDown) then
   begin
      BDown := False;
      Hold  := False;
      for i := 1 to MCount do
        MouseSttPtrs[i]^ := False;
      LastMX := 0;
      LastMY := 0;
   end;
   CheckShift;
   Music.UpDate;
{   GetKeys;}
end;

Procedure CheckShift;
var
 b : byte;
begin
   if Port[$60] >= $80+128 then exit;
   if Port[$60] = 42 then
   begin
      Shift := True;
   end;
   if Port[$60] = 42+128 then
   begin
      Shift := False;
   end;
{   Shift:=((mem[$0:$0417] and $02)=$02);}
end;

Procedure InitTimer;
begin
   BDown  := False;
   BClick := False;
   LastMx := 0;
   LastMy := 0;
   DCTime := 0;
   GetIntVec($1C,SaveInt1);
   SetIntVec($1C,Addr(TimerHandler));
end;

Procedure KillTimer;
begin
   SetIntVec($1C,SaveInt1);
end;

Procedure TRect.Assign(Px,Py,Px1,Py1 : integer);
begin
   x  := px;
   y  := py;
   x1 := px1;
   y1 := py1;
end;

Procedure TRect.MoveByR(R : TRect);
begin
   Inc(x, R.x);
   Inc(x1, R.x);
   Inc(y, R.y);
   Inc(y1, R.y);
end;

Function TRect.GetMiddleX : integer;
begin
   GetMiddleX := x+ ((x1-x) div 2)
end;

Function TRect.GetMiddleY : integer;
begin
   GetMiddleY := y+ ((y1-y) div 2)
end;


Function  TRect.MouseOnMe : Boolean;
var
 mx, my : integer;
begin
   MouseOnMe := False;
   mx := GetMouseX;
   my := GetMouseY;
   if (mx >= x) and (mx <= x1) and
      (my >= y) and (my <= y1) then
       MouseOnMe := True;
end;

Function  TRect.ClickedOnMe : Boolean;
var
 mx, my : integer;
begin
   ClickedOnMe := False;
   mx := LastMx;
   my := LastMy;
   if (mx >= x) and (mx <= x1) and
      (my >= y) and (my <= y1) then
       ClickedOnMe := True;
end;

Procedure TRect.Bar(Color : Byte);
begin
   SetFillStyle(1,Color);
   Graph.Bar(x,y,x1,y1);
end;

Procedure TRect.Rectangle(Color : Byte);
var
 bkcolor : byte;
begin
   BkColor := GetColor;
   SetColor(Color);
   Graph.Rectangle(x,y,x1,y1);
   SetColor(bkcolor);
end;

Procedure TRect.Move(Px,Py : integer);
begin
   x := x + px;
   x1 := x1 + px;
   y := y + py;
   y1 := y1 + py;
end;

Function  TRect.InMe(px,py : integer) : Boolean;
begin
   if (px >= x) and (px <= x1) and
      (py >= y) and (py <= y1) then
       InMe := True
      else
       InMe := False;
end;

Function  TRect.GetXDiff   : integer;
begin
   GetXDiff := Abs(x1-x);
end;

Function  TRect.GetYDiff   : integer;
begin
   GetYDiff := Abs(y1-y);
end;

Procedure ClearKeyBuff;
begin
   if KeyPressed then
    ReadKey;
end;

Procedure InsertMSP(B : PBool);
begin
   Inc(MCount);
   MouseSttPtrs[MCount] := B;
end;

Constructor TGObject.Init;
begin
end;

Destructor TGObject.Done;
begin
end;

Procedure TGObject.TimeUpDate;
begin
end;

begin
   MenuSColor := 1;
   MenuBkColor := 7;
   MenuTColor := 0;
   MenuTSColor := 15;

   MenuItmHeight := 15;
   MenuItmLHeight := 9;
   CallSys := False;
   Shift := False;
   BDown := False;
   Hold  := False;
   MCount := 0;
   Music.Play('');
end.
