unit SysObj;
{------------------------------------------------------------}
{  \   /  ==  ==|==  /\  |\    /|'/===                       }
{   \ /  |  |   |   |  | | \  / | \___                       }
{    |   |  |   |   |__| |  \/  |    |                       }
{    |    ==    |   |  | |      | \__/                       }
{                                                            }
{  \      / O /=== O  ==  |\   |                             }
{   \    /  | \___ | |  | | \  |                             }
{    \  /   |    | | |  | |  \ |  By:                        }
{     \/    | \__/ |  ==  |   \|  Dr. Yotam Madem            }
{                                                            }
{    P.G.I                                                   }
{   -------                                                  }
{   Powerfull Graphic Interface with multitasking            }
{   P.G.I(tm) Copyright(c) 1999 by Y.M.S(r) -                }
{   Yotam. Madem. Software. Corporation.                     }
{------------------------------------------------------------}
{   SYSOBJ.PAS - PGI Unit including many system objects.     }
{------------------------------------------------------------}
interface

  uses a_Mouse, BGI2, Draw_Obj, BasicObj, RBasicT, YFonts, ClipBord, Keys;

Type
  PForm  = ^TForm;
  TForm  = Object(TView)
                Objects       : Array[1..30] of PView;
                ObjCount      : integer;
                OnObj         : integer;
                WinNum        : integer;
                DoObj         : integer;
                Constructor init(PR : TRect; PCode : integer;
                                 PTitle : String);
                Procedure DoMenu;                      virtual;
                Function  MouseOnMe : Boolean;         virtual;
                Procedure Insert(P : PView);           virtual;
                Procedure Act(var Event : TEvent);     virtual;
                Procedure Draw;                        virtual;
                Procedure DrawTitle(TActive : boolean);virtual;
                Procedure Move(x,y : integer);         virtual;
                Procedure Clamp(P : TPoint);           virtual;
                Procedure UnClamp;                     virtual;
                Procedure Select;                      virtual;
                Procedure UnSelect;                    virtual;
                Procedure ChEvUsr(var Event : TEvent); virtual;
                Procedure DoEvUsr(var Event : TEvent); virtual;
                Procedure TimeUpDate;                  virtual;
                Procedure SetAreas;                    virtual;
                Procedure OnMove;                      virtual;
                Function ClsBPresd : Boolean;          virtual;
                Function MaxBPresd : Boolean;          virtual;
                Function MnuBPresd : Boolean;          virtual;
                Function MinBPresd : Boolean;          virtual;
                Function RszBPresd : Boolean;          virtual;
                Destructor done;                       virtual;
           end;

  PMacForm = ^TMacForm;
  TMacForm = Object(TForm)
                M : MacWindow;
                Constructor init(PR : TRect; PCode : integer;
                                 PTitle : String);
                Procedure Draw;                        virtual;
                Procedure DrawTitle(TActive : boolean);virtual;
                Function ClsBPresd : Boolean;          virtual;
                Function MaxBPresd : Boolean;          virtual;
                Procedure SetAreas;                    virtual;
                Destructor done;                       virtual;
             end;

  PButton  = ^TButton;
  TButton  = Object(TView)
                Name     : String;
                Mes      : Boolean;
                HotKey   : KeyType;
                HKLetter : byte;
                Style    : Byte;
                Constructor init(PR : TRect; PCode : integer;
                                 PName : String; PHKey : KeyType; HKL, Ps : integer);
                Procedure Draw;                    virtual;
                Procedure Act(var Event : TEvent); virtual;
                Function  CheckMouse : Boolean;    virtual;
                Function  PressButton : Boolean;   virtual;
                Procedure Select;                  virtual;
                Procedure UnSelect;                virtual;
                Procedure SetAreas;                virtual;
                Destructor done;                   virtual;
             end;

  PMacButton = ^TMacButton;
  TMacButton = Object(TButton)
                  Constructor init(PR : TRect; PCode : integer; PName : String; PHKey : KeyType);
                  Procedure Draw; virtual;
               end;

  PEdit    = ^TEdit;
  TEdit    = Object(TView)
                Max      : integer;
                S        : String;
                EL       : integer; {Editbox Lenght (Text's)}
                Display  : TPoint;
                SelAera  : TPoint;  {Selected Aera}
                TA       : TPoint;  {Temp Selected Aera}
                SamanP   : integer;
                TextY    : integer;
                TextX    : integer;
                SCount   : byte;
                SmnOn    : Boolean;
                LastTime : Longint;
                PSelect  : Boolean;
                KeySet   : String; {Edit's Acceptable keys}
                SamanColor : byte;
                STextC   : byte;
                Constructor Init(PR : TRect; PCode : integer;
                                 PDef, PKeySet : String;
                                 PMax : integer);
                Procedure Draw;                             virtual;
                Procedure DispText(PDisplay : TPoint;
                                       sX : integer);       virtual;
                Procedure DispSaman(OnOff : boolean);       virtual;
                Function  GetMaxText : integer;             virtual;
                Procedure Act(var Event : TEvent);          virtual;
                Procedure Select;                           virtual;
                Procedure UnSelect;                         virtual;
                Procedure TimeUpDate;                       virtual;
                Procedure SetAreas;                         virtual;
                Procedure OnMove;                           virtual;
                Function  CalcMPos(x:integer):integer;      virtual;
                Procedure MoveSamanRight;                   virtual;
                Procedure MoveSamanLeft;                    virtual;
                Procedure SelectRight;                      virtual;
                Procedure SelectLeft;                       virtual;
                Procedure KHome;                            virtual;
                Procedure KEnd;                             virtual;
                Procedure DeleteText;                       virtual;
                Procedure DoBackSpace;                      virtual;
                Function HandleLetter(Ch : Char) : boolean; virtual;
                Procedure CopyToClipB;                      virtual;
                Procedure PasteFromClipB;                   virtual;
                Procedure CutToClipB;                       virtual;
                Destructor done;                            virtual;
             end;

  PMacEdit    = ^TMacEdit;
  TMacEdit    = Object(TEdit)
                      Constructor Init(PR : TRect; PCode : integer;
                                       PDef, PKeySet : String;
                                       PMax : integer);
                      Procedure Draw;                        virtual;
                end;

  PLabel = ^TLabel;
  TLabel = object(TView)
             Str    : String80;
             HotKey : KeyType;
             ObjPtr : PGObject;
             HKLetter : Byte;
             x,y,x1 : integer;
             Constructor Init(pr : TRect; PStr : String80;
                              POP : PGObject; HK : KeyType; hkl : byte);
             Procedure  Act(var Event : TEvent); virtual;
             Procedure  Draw;                    virtual;
             Destructor Done;                    virtual;
           end;

  PCluster  = ^TCluster;
  TCluster  = record
                r      : TRect;
                Title  : String80;
                HotKey : KeyType;
                HKL    : Byte;
                Mode   : boolean;
              end;

  PClusters = ^TClusters;
  TClusters = object(TView)
                 Clusters : Array[1..100] of PCluster;
                 NumC     : byte;
                 Saman    : byte;
                 Constructor Init(pr : TRect);
                 Procedure Insert(x,y : word; title : string80; Hk : KeyType; HKL : Byte);
                 Procedure DrawCluster(index : byte);     virtual;
                 Procedure Draw;                          virtual;
                 Procedure Act(var Event : TEvent);       virtual;
                 Procedure Select;                        virtual;
                 Procedure UnSelect;                      virtual;
                 Procedure MouseAct(var Event : TEvent);  virtual;
                 Procedure KeysAct(var Event : TEvent);   virtual;
                 Destructor done;                         virtual;
              end;

  PTicks = ^TTicks;
  TTicks = object (TClusters)
              Constructor Init(pr : TRect);
              Procedure Insert(x,y : word; title : string80; Hk : KeyType; HKL : Byte;
                               mode : boolean);
              Procedure DrawCluster(index : byte);     virtual;
              Procedure Act(var Event : TEvent);       virtual;
              Procedure MouseAct(var Event : TEvent);  virtual;
              Procedure KeysAct(var Event : TEvent);   virtual;
           end;

   PWinFace = ^TWinFace;
   TWinFace = object(TView)
                 Constructor Init(PR : TRect);
                 Procedure Draw; virtual;
              end;

   PStatusLine = ^TStatusLine;
   TStatusLine = object(TView)
                    Text : String;
                    Constructor Init(s : string);
                    Procedure Draw;                    virtual;
                    Procedure WriteStatus(s : string); virtual;
                    Procedure InitWithOwner;           virtual;
                 end;

implementation

{-----------------------<<<<<< TStatusLine >>>>>>---------------------------}
Constructor TStatusLine.Init(s : string);
var
 On : TRect;
begin
   On.Assign(0,0,0,0);
   Inherited init(On,0);
   Text := s;
   CanBeSelected := False;
   CanBePointed := False;
end;

Procedure TStatusLine.InitWithOwner;
var
 On : TRect;
begin
   On.x := 0;
   On.y := 0;
   On.x1 := Owner^.r.x1-Owner^.r.x;
   On.y1 := Owner^.r.y1-Owner^.r.y;
   R.Assign(4,On.y1-20,On.x1-18,On.y1-4);
end;

Procedure TStatusLine.Draw;
var
 On : TRect;
begin
   SetDrawViewPort;
   Hidemouse;
   Pannel(R,False);
{   DrawBitMap(StatusLine,r.x1+3,r.y1-13,15,15,0);}
   if Text <> '' then
   begin
      SetColor(0);
      MoveTo(r.x+2,r.y+2);
      YOutText(Text);
   end;
   ShowMouse;
   RestoreDrawViewPort;
end;

Procedure TStatusLine.WriteStatus(s : string);
begin
   Text := s;
   Draw;
end;

{-------------------------<<<<<< TWinFace >>>>>>---------------------------}
Constructor TWinFace.Init(Pr : TRect);
begin
   Inherited init(pr,0);
   CanBeSelected := False;
   CanBePointed := False;
end;

Procedure TWinFace.Draw;
begin
   SetDrawViewPort;
   WinFace(r);
   RestoreDrawViewPort;
end;

{------------------------<<<<<< TClusters >>>>>>---------------------------}
Constructor TClusters.Init(pr : TRect);
begin
   inherited init(pr,1);
   NumC := 0;
   Saman := 1;
   CanBeSelected := true;
   CanBePointed := true;
   Selected := False;
end;

Procedure TClusters.Insert(x,y : word; title : string80; Hk : KeyType; HKL : Byte);
begin
   Inc(NumC);
   New(Clusters[numc]);
   Clusters[numc]^.r.x := x;
   Clusters[numc]^.r.y := y;
   Clusters[numc]^.title := title;
   Clusters[numc]^.Hotkey := Hk;
   Clusters[numc]^.Hkl := Hkl;
   Clusters[numc]^.r.y1 := y+YTextHeight(title);
end;

Procedure TClusters.DrawCluster(index : byte);
var
 mode : boolean;
 rr    : trect;
 tr    : trect;
begin
   if saman = index then
    mode := true
   else
    mode := false;
   rr := Clusters[index]^.R;
   rr.x := r.x+rr.x;
   rr.y := r.y+rr.y;
   SetColor(WinFaceColor);
   Rectangle(rr.x+13,rr.y,rr.x+YTextWidth(Clusters[index]^.Title)+16,rr.y+12);
   GCluster(rr,mode);
   moveto(rr.x+16,rr.y+1);
   tr.Assign(rr.x+16,rr.y+1,0,0);
   SetColor(0);
   YOutTextU(Clusters[index]^.Title,Clusters[index]^.HKL,tr);
   SetLineStyle(4,OSStyle,1);
   if (mode) and (Selected) then
    Rectangle(rr.x+13,rr.y,rr.x+YTextWidth(Clusters[index]^.Title)+16,rr.y+12);
   SetLineStyle(0,0,0);
end;

Procedure TClusters.Select;
begin
   inherited Select;
   Draw;
end;

Procedure TClusters.UnSelect;
begin
   inherited UnSelect;
   Draw;
end;

Procedure TClusters.Draw;
var
 i : integer;
begin
   hidemouse;
   SetDrawViewPort;
   for i := 1 to NumC do
     DrawCluster(i);
   RestoreDrawViewPort;
   showmouse;
end;

Procedure TClusters.MouseAct(var Event : TEvent);
var
 i : integer;
 rc, tr : TRect;
begin
   if (Event.T.ME = RButton) or (Event.T.ME = LButton) then
   begin
      for i := 1 to NumC do
      begin
        if I <> Saman then
        begin
           tr := Clusters[i]^.R;
           RC.Assign(R.X+TR.X+Owner^.R.x,
                     R.Y+TR.Y+Owner^.R.y,
                     R.X1+Owner^.R.x,
                     R.Y+TR.Y1+Owner^.R.y);
           if RC.MouseOnMe then
           begin
              Saman := I;
              Draw;
              Break;
           end;
        end;
      end;
   end;
end;

Procedure TClusters.KeysAct(var Event : TEvent);
begin
   if Event.T.ifKey then
   case Event.T.Key of

          #80{Down} :if (Event.T.c0) and (Saman < NumC) then
                     begin
                        Inc(Saman);
                        Draw;
                     end;

          #72{Up}   :if (Event.T.c0) and (Saman > 1) then
                     begin
                        Dec(Saman);
                        Draw;
                     end;

   end;
end;

Procedure TClusters.Act(var Event : TEvent);
var
 i : integer;
begin
   if Event.What <> evUsrInput then Exit;
   for i := 1 to NumC do
   begin
      if Clusters[i]^.Hotkey.Accepted(Event.T) then
      begin
         Saman := I;
         Draw;
         Event.What := evObjToObj;
         Event.Command := cmSelectObj;
         Event.SenderPtr := @Self;
         Break;
      end;
   end;
   if Not Selected then Exit;
   MouseAct(Event);
   KeysAct(Event);
end;

Destructor TClusters.done;
var
 i : integer;
begin
   inherited done;
   for i := 1 to NumC do
     Dispose(Clusters[i]);
end;

{----------------------------<<<<<< TTicks >>>>>>---------------------------}

Constructor TTicks.Init(pr : TRect);
begin
   inherited init(pr);
end;

Procedure TTicks.Insert(x,y : word; title : string80; Hk : KeyType; HKL : Byte; mode : boolean);
begin
   inherited insert(x,y,title,hk,hkl);
   Clusters[numc]^.mode := mode;
end;

Procedure TTicks.DrawCluster(index : byte);
var
 mode : boolean;
 rr    : trect;
 tr    : trect;
begin
   rr := Clusters[index]^.R;
   mode := Clusters[index]^.mode;
   rr.x := r.x+rr.x;
   rr.y := r.y+rr.y;
   SetColor(WinFaceColor);
   Rectangle(rr.x+13,rr.y,rr.x+YTextWidth(Clusters[index]^.Title)+16,rr.y+12);
   GTick(rr,mode);
   moveto(rr.x+16,rr.y+1);
   tr.Assign(rr.x+16,rr.y+1,0,0);
   SetColor(0);
   YOutTextU(Clusters[index]^.Title,Clusters[index]^.HKL,tr);
   SetLineStyle(4,OSStyle,1);
   if (saman = index) and (Selected) then
    Rectangle(rr.x+13,rr.y,rr.x+YTextWidth(Clusters[index]^.Title)+16,rr.y+12);
   SetLineStyle(0,0,0);
end;

Procedure TTicks.MouseAct(var Event : TEvent);
var
 i : integer;
 rc, tr : TRect;
begin
   if (Event.T.ME = RButton) or (Event.T.ME = LButton) then
   begin
      for i := 1 to NumC do
      begin
         tr := Clusters[i]^.R;
         RC.Assign(R.X+TR.X+Owner^.R.x,
                   R.Y+TR.Y+Owner^.R.y,
                   R.X1+Owner^.R.x,
                   R.Y+TR.Y1+Owner^.R.y);
         if RC.MouseOnMe then
         begin
            Saman := I;
            Clusters[i]^.mode := not Clusters[i]^.mode;
            Draw;
            repeat DoSystem until buttonup;
            Break;
         end;
      end;
   end;
end;

Procedure TTicks.KeysAct(var Event : TEvent);
begin
   if Event.T.ifKey then
   case Event.T.Key of

          #80{Down} :if (Event.T.c0) and (Saman < NumC) then
                     begin
                        Inc(Saman);
                        Draw;
                     end;

          #72{Up}   :if (Event.T.c0) and (Saman > 1) then
                     begin
                        Dec(Saman);
                        Draw;
                     end;
          ' '       :if (not Event.T.c0) then
                     begin
                        Clusters[Saman]^.mode := not Clusters[Saman]^.mode;
                        Draw;
                     end;


   end;
end;

Procedure TTicks.Act(var Event : TEvent);
var
 i : integer;
begin
   if Event.What <> evUsrInput then Exit;
   for i := 1 to NumC do
   begin
      if Clusters[i]^.Hotkey.Accepted(Event.T) then
      begin
         Saman := I;
         Clusters[Saman]^.mode := not Clusters[Saman]^.mode;
         Draw;
         Event.What := evObjToObj;
         Event.Command := cmSelectObj;
         Event.SenderPtr := @Self;
         Break;
      end;
   end;
   if Not Selected then Exit;
   MouseAct(Event);
   KeysAct(Event);
end;



{----------------------------<<<<<< TLabel >>>>>>---------------------------}

Constructor TLabel.Init(pr : TRect; PStr : String80;
                             POP : PGObject; HK : KeyType; HKL : byte);
begin
   TView.init(pr,0);
   Str := PStr;
   ObjPtr := POP;
   HotKey := HK;
   HKLetter := HKL;
   CanBePointed := False;
   CanBeSelected := False;
end;

Procedure TLabel.Act(var Event : TEvent);
begin
   if Event.What <> evUsrInput then Exit;
   if HotKey.Accepted(Event.T) then
   begin
      Event.What := evObjToObj;
      Event.Command := cmSelectObj;
      Event.SenderPtr := ObjPtr;
   end;
end;

Procedure TLabel.Draw;
begin
   hidemouse;
   SetDrawViewPort;
   MoveTo(r.x,r.y);
   SetColor(0);
   YOutTextU(Str,HKLetter,r);
   RestoreDrawViewPort;
   showmouse;
end;

Destructor TLabel.Done;
begin
   inherited done;
end;

{----------------------------<<<<<< TEdit >>>>>>---------------------------}

Constructor TEdit.Init(PR : TRect; PCode : integer;
                       PDef, PKeySet : String;
                       PMax : integer);
begin
   TView.Init(PR, PCode);
   Max := PMax;
   S   := PDef;
   KeySet := PKeySet;
   EL  := ((r.x1-r.x-3) div 8);
   Display.x := 1;
   Display.y := 1+EL;
   SelAera.x := 0;
   SelAera.y := 0;
   SamanP := GetMaxText;
   CanBeSelected := True;
   CanBePointed := True;
   SmnOn := False;
   Active := False;
   SCount := 0;
   if Length(s) > Max then
    Delete(s,max+1,Length(s)-max+1);
   SamanColor := 1;
   STextC := 15;
end;

Function TEdit.GetMaxText : integer;
begin
   GetMaxText := EL+1;
   if Length(s)+1 < EL+1 then
     GetMaxText := Length(s)+1;
end;

Procedure TEdit.SetAreas;
begin
   TextY := R.y1-13;
   TextX := R.x+4;
end;

Procedure TEdit.OnMove;
begin
   if Active then
   begin
      SCount := 0;
   end;
   SetAreas;
end;

Procedure TEdit.TimeUpDate;
begin
   if not Active then Exit;
   if DCTime <> LastTime then
   begin
      LastTime := DCTime;
      if SCount < 6 then
       Inc(SCount)
      else
       begin
          SCount := 0;
          DispSaman(not SmnOn);
       end;
   end;
end;

Procedure TEdit.DispText(PDisplay : TPoint; sX : integer);
var
 i          : integer;
 SA         : TPoint;
 SAt        : TPoint;
 txt,ss     : string;
 diff       : integer;
 LF         : Boolean;

Procedure BarAera(PDisp : TPoint; Color : Byte);
var
 x,y,x1,y1 : integer;
begin
   x := sx+TextX+(((PDisp.x-(PDisplay.x-1))-1)*8);
   y := r.y+2;
   x1 := X+((PDisp.GetDifference)*8);  {8=TxtWidth}
   y1 := r.y1-2;
   SetFillStyle(1,Color);
   bar(x,y,x1,y1);
end;

Procedure BarAera2(PDisp : TPoint; Color : Byte);
var
 x,y,x1,y1 : integer;
begin
   x := sx+TextX;
   y := r.y+2;
   x1 := X+((PDisp.GetDifference)*8);
   y1 := r.y1-2;
   SetFillStyle(1,Color);
   bar(x,y,x1,y1);
end;


begin
   HideMouse;
   SetDrawViewPort;
   LF := SysF;
   SysF := True;
   BarAera2(PDisplay,15);
   SA.x := 0;
   SA.y := 0;
   SAt.x := 0;
   SAt.y := 0;
   if SelAera.GetDifference = 0 then
   begin
      SelAera.x:=0;
      SelAera.y:=0;
   end;
   if (not ((SelAera.x = 0)or(SelAera.y = 0)))then
   begin
      SA := SelAera;
      if SA.y > PDisplay.y then SA.y := PDisplay.y;
      if SA.x < PDisplay.x then SA.x := PDisplay.x;

      SAt := SelAera;
      if SAt.y > Display.y then SAt.y := Display.y;
      if SAt.x < Display.x then SAt.x := Display.x;
   end;

   if SelAera.y < PDisplay.x+1 then
    SA.x := 0;

   if SA.x <> 0 then
     BarAera(SA,SamanColor);

   SS := S;
   if Length(SS) < PDisplay.y then
   begin
      Diff := PDisplay.y - Length(SS);
      for i := 1 to diff do
       SS := SS + ' ';
   end;

   begin
      txt := Copy(SS, PDisplay.x,PDisplay.GetDifference);
      MoveTo(TextX+sx,TextY);
      SetColor(0);
      YOutText(txt);
   end;
   if (SAt.x <> 0) then
   begin
      txt := Copy(SS, SAt.x,SAt.GetDifference);
      MoveTo(sx+TextX+((SAt.X-(PDisplay.x-1))-1)*YTextWidth('H'),TextY);
      SetColor(STextC);
      YOutText(txt);
   end
  else
   if (SA.x <> 0) then
   begin
      txt := Copy(SS, SA.x,SA.GetDifference);
      MoveTo(sx+TextX+((SA.X-(PDisplay.x-1))-1)*YTextWidth('H'),TextY);
      SetColor(STextC);
      YOutText(txt);
   end;
   ShowMouse;
   RestoreDrawViewPort;
   SysF := LF;
end;

Procedure TEdit.DispSaman(OnOff : boolean);
var
 x,y,y1 : integer;
 LastWM : integer;
begin
   if SmnOn = OnOff then Exit;
   SmnOn := OnOff;

   HideMouse;
   SetDrawViewPort;
   SetColor(15);
   y := r.y+2;
   y1 := r.y1-2;
   x := TextX+((SamanP-1)*8);  {8=Text Width}
   LastWM := CurrWriteMode;
   SetWriteMode(XORPut);
   Line(x,y,x,y1);
   Line(x+1,y,x+1,y1);
   SetWriteMode(LastWM);
   RestoreDrawViewPort;
   ShowMouse;
end;

Procedure TEdit.Draw;
begin
   HideMouse;
   SetDrawViewPort;
   WinFace(R);
   RestoreDrawViewPort;
   SmnOn := False;
   if S <> '' then
     DispText(Display,0);
   if Active then
     DispSaman(True);
   ShowMouse;
end;

{CalcMPos -                                   }
{Converts the mouse position to saman position}
Function TEdit.CalcMPos(x : integer) : integer;
var
 dx, smn : integer;
begin
   dx := x-r.x;
   Smn := dx div 8;
   Inc(Smn);
   if Smn < 1 then Smn := 1;
   if Smn > EL+1 then Smn := EL+1;
   if Smn > Length(S)+1 then Smn := Length(S)+1;
   CalcMPos := Smn;
end;

Procedure TEdit.SelectRight;
var
 SA : TPoint;
begin
   PSelect := False;
   if not Shift then
   begin
      if SelAera.x <> 0 then
      begin
         SelAera.x := 0;
         SelAera.y := 0;
         DispText(Display,0);
      end;
      Exit;
   end;
    SA := SelAera;
    if SA.y > Display.y then
     SA.y := Display.y;
    begin
       if SelAera.x = 0 then
       begin
         SelAera.x := SamanP+Display.x-1;
         SelAera.y := SamanP+Display.x;
         if SamanP < EL+1 then
           DispText(SelAera,(SelAera.x-Display.x)*8);
       end
      else
       begin
          if (SelAera.x = SamanP+Display.x-1) and (SelAera.y > SelAera.x)
           then
             begin
                Inc(SelAera.x);
                if SamanP < EL+1 then
                begin
                   if SelAera.x = SelAera.y then
                   begin
                      SelAera.x:=0;
                      SelAera.y:=0;
                   end;
                   SA.y := SA.x+1;
                   DispText(SA,(SA.x-Display.x)*8);
                end;
             end
           else
             begin
                Inc(SelAera.y);
                if SamanP < EL+1 then
                begin
                   SA := SelAera;
                   SA.x := SA.y-1;
                   DispText(SA,(SA.x-Display.x)*8);
                end;
             end;
       end;
    end;
end;

Procedure TEdit.SelectLeft;
var
 SA : TPoint;
begin
   PSelect := False;
   if not Shift then
   begin
      if SelAera.x <> 0 then
      begin
         SelAera.x := 0;
         SelAera.y := 0;
         DispText(Display,0);
      end;
      Exit;
   end;
   SA := SelAera;
   if (SamanP > 1) or (Display.x > 1) then
   begin
       if SelAera.x = 0 then
       begin
         SelAera.x := SamanP+Display.x-2;
         SelAera.y := SamanP+Display.x-1;
         if SamanP > 1 then
           DispText(SelAera,(SelAera.x-Display.x)*8);
       end
      else
       begin
          if (SelAera.x < SamanP+Display.x-1) and (SelAera.y > SelAera.x)
           then
             begin
                Dec(SelAera.y);
                SA.x := SA.y-1;
                SA.y := Display.y;
                if SamanP > 1 then
                  DispText(SA,(SA.x-Display.x)*8);
             end
           else
             begin
                Dec(SelAera.x);
                SA := SelAera;
                SA.y := SA.x+1;
                if SamanP > 1 then
                  DispText(SA,(SA.x-Display.x)*8);
             end;
       end;
    end;
end;

Procedure TEdit.MoveSamanLeft;
begin
   if SamanP > 1 then
   begin
      SCount := 0;
      DispSaman(False);
      SelectLeft;
      Dec(SamanP);
      DispSaman(True);
   end
  else
   begin
      if Display.x > 1 then
      begin
         SCount := 0;
         DispSaman(False);
         SelectLeft;
         Dec(Display.x);
         Dec(Display.y);
         DispText(Display,0);
         DispSaman(True);
      end
     else
      if (SelAera.x <> 0) and (not Shift) then
      begin
         SelAera.x := 0;
         SelAera.y := 0;
         SCount := 0;
         DispSaman(False);
         DispText(Display,0);
         DispSaman(True);
      end;
   end;
end;

Procedure TEdit.MoveSamanRight;
begin
   if (SamanP < EL+1) then
   begin
      if Display.x+SamanP-1 < Length(S)+1 then
      begin
         SCount := 0;
         DispSaman(False);
         SelectRight;
         Inc(SamanP);
         DispSaman(True);
       end;
   end
 else
   begin
      if Display.y-1 < Length(s) then
      begin
         SCount := 0;
         DispSaman(False);
         SelectRight;
         Inc(Display.x);
         Inc(Display.y);
         DispText(Display,0);
         DispSaman(True);
      end
     else
      if (SelAera.x <> 0) and (not Shift) then
      begin
         SelAera.x := 0;
         SelAera.y := 0;
         SCount := 0;
         DispSaman(False);
         DispText(Display,0);
         DispSaman(True);
      end;
   end;
end;

Procedure TEdit.KHome;
var
 Ls : integer;
 LD : TPoint;
begin
   if SamanP <= 1 then Exit;
   SCount := 0;
   DispSaman(False);
   Ls := SamanP;
   LD := Display;
   Display.x := 1;
   Display.y := EL+1;
   if Shift then
   begin
      if LD.x+SamanP-1 <= SelAera.y-1 then
      begin
         if SelAera.y=0 then
           SelAera.y := Ls+LD.x-1;
         SelAera.x := 1;
      end
     else
      begin
         if SelAera.x <> 0 then
         begin
            SelAera.y := SelAera.x;
            SelAera.x := 1;
         end
        else
         begin
            SelAera.y := Ls+LD.x-1;
            SelAera.x := 1;
         end;
      end;
   end
  else
   begin
      SelAera.y := 0;
      SelAera.x := 0;
   end;
   SamanP := 1;
   DispText(Display,0);
   DispSaman(True);
end;

Procedure TEdit.KEnd;
var
 ls : integer;
 LD : TPoint;
begin
   if SamanP >= GetMaxText then Exit;
   ls := SamanP;
   LD := Display;
   SCount := 0;
   DispSaman(False);
   if Length(s) > EL then
   begin
      Display.y := Length(S)+1;
      Display.x := Display.y-EL;
   end;
   if Shift then
   begin
      if LD.x+SamanP-1 >= SelAera.y then
      begin
         if SelAera.x=0 then
           SelAera.x := LD.x+Ls-1;
         SelAera.y := Display.x+GetMaxText-1;
      end
     else
      begin
         SelAera.x := SelAera.y;
         SelAera.y := Display.x+GetMaxText-1;
      end;
   end
  else
   begin
      SelAera.x := 0;
      SelAera.y := 0;
   end;
   SamanP := GetMaxText;
   DispText(Display,0);
   DispSaman(True);
end;

Procedure TEdit.DoBackSpace;
var
 Def, DS : integer;
begin
   if SelAera.x <> 0 then
     DeleteText
    else
     begin
        SCount := 0;
        DispSaman(False);
        if (Display.x <= 1) and (SamanP <= 1) then
        begin
           DispSaman(True);
           Exit;
        end;
        if SamanP = 1 then
        begin
           if EL > Display.x-1 then
              Def := Display.x-1
             else
              Def := EL;
           DS := SamanP+Display.x;
           Delete(s,Display.x+SamanP-2,1);
           Dec(Display.x,def);
           Dec(Display.y,def);
           SamanP := DS-Display.x-1;
           DispText(Display,0);
           DispSaman(True);
        end
       else
        begin
           dec(SamanP);
           DeleteText;
        end;
     end;
end;

Procedure TEdit.DeleteText;
var
 smn : integer;
 SA  : TPoint;
begin
   SA := Display;
   SCount := 0;
   DispSaman(False);
   if SelAera.x <> 0 then
   begin
      Delete(S,SelAera.x,SelAera.GetDifference);
      if (SelAera.x - EL) > 0 then
      begin
         Display.y := SelAera.x;
         Display.x := SelAera.x-EL;
      end
     else
      begin
         Display.x := 1;
         Display.y := EL+1;
      end;
      smn := SelAera.x-Display.x+1;
      SelAera.x := 0;
      SelAera.y := 0;
      DispText(Display,0);
   end
  else
   begin
      smn := SamanP;
      Delete(s,Display.x+SamanP-1,1);
      SA.x := Display.x+SamanP-1;
      SA.y := Display.y;
      DispText(SA,(SA.x-Display.x)*8);
   end;
   SamanP := Smn;
   DispSaman(True);
end;

Function TEdit.HandleLetter(Ch : Char) : Boolean;
var
 SA : TPoint;
begin
   HandleLetter := False;
   if Pos(Ch, KeySet) = 0 then Exit;
   HandleLetter := True;
   if (Ch = '4') and (KLeft) then Exit;
   if (Ch = '6') and (KRight) then Exit;

   Shift := False;
   if SelAera.x = 0 then
   begin
      if Length(s) = Max then Exit;
      Insert(Ch,S,SamanP+Display.x-1);
      if SamanP < EL+1 then
      begin
         SA.x := Display.x+SamanP-1;
         SA.y := Display.y;
         MoveSamanRight;
         SCount := 0;
         DispSaman(False);
         if (SamanP < EL+1) then
           DispText(SA,(SA.x-Display.x)*8)
          else
           DispText(Display,0);
         DispSaman(True);
      end
     else
      MoveSamanRight;
   end
  else
   begin
      DeleteText;
      if Length(s) = Max then Exit;
      Insert(Ch,S,SamanP+Display.x-1);
      if SamanP < EL+1 then
      begin
         MoveSamanRight;
         SCount := 0;
         DispSaman(False);
         DispText(Display,0);
         DispSaman(True);
      end
     else
      MoveSamanRight;
   end;
end;

Procedure TEdit.CopyToClipB;
begin
   if SelAera.x = 0 then Exit;
   ClipBordData := Copy(S,SelAera.x,SelAera.GetDifference);
end;

Procedure TEdit.CutToClipB;
begin
   if SelAera.x = 0 then Exit;
   ClipBordData := Copy(S,SelAera.x,SelAera.GetDifference);
   DeleteText;
end;


Procedure TEdit.PasteFromClipB;
var
 i : integer;
begin
   if ClipBordData = '' then Exit;
   for i := 1 to Length(ClipBordData) do
     HandleLetter(ClipBordData[i]);
end;


Procedure TEdit.Act(var Event : TEvent);
var
 Smn : integer;
 SA  : TPoint;
 temp : integer;
 TR : TRect;
begin
   if not Active then Exit;
   if Event.T.ME <> none then
   begin
      TR := R;
      TR.Move(Owner^.r.x,Owner^.r.y);
      if not TR.ClickedOnMe then Exit;
      Smn := CalcMPos(GetMouseX-Owner^.r.x);
      if SelAera.x <> 0 then
      begin
         SelAera.x := 0;
         SelAera.y := 0;
         SCount := 0;
         DispSaman(False);
         DispText(Display,0);
      end;
      if SamanP <> Smn then
      begin
         SCount := 0;
         DispSaman(False);
         SamanP := Smn;
         DispSaman(True);
      end;
   end
  else
   if Event.T.ifKey then
   begin
      Case Event.T.Key of

            #77:if Event.T.c0 then
                   MoveSamanRight;{Right key}

            #75:if Event.T.c0 then
                   MoveSamanLeft;{Left Key}

            #71:if Event.T.c0 then
                   KHome;{Home Key}

            #79:if Event.T.c0 then
                   KEnd;{End Key}

            #83:if Event.T.c0 then
                   DeleteText;{Delete Key}

            #8 : if not Event.T.c0 then
                   DoBackSpace; {Backspace}

            #3 : if not Event.T.c0 then
                   CopyToClipB;

            #22: if not Event.T.c0 then
                   PasteFromClipB;

            #24: if not Event.T.c0 then
                   CutToClipB;

      end;

      if (not Event.T.c0) then
      begin
         if (Event.T.Key <> #8) and (Event.T.Key <> #9) then
         begin
            if HandleLetter(Event.T.Key) then
            begin
               Event.What := evNoEvent;
               Event.T.Key := ' ';
            end;
         end
        else
         Event.What := evUsrInput;
      end;
   end;
end;

Procedure TEdit.Select;
begin
   if SelectedByKB then
   begin
      if Length(S) <=EL then
      begin
         Display.x := 1;
         Display.y := 1+EL;
      end
    else
      begin
         Display.y := Length(s)+1;
         Display.x := Display.y-EL;
      end;
      SCount := 0;
      DispSaman(False);
      SamanP := GetMaxText;
      SelAera.x := 1;
      SelAera.y := 1+Length(s);
      DispText(Display,0);
   end
  else
   SelAera := TA;
   DispSaman(True);
   Active := True;
end;

Procedure TEdit.UnSelect;
begin
   DispSaman(False);
   TA := SelAera;
   if SelAera.GetDifference > 0 then
   begin
      SelAera.x:=0;
      SelAera.y:=0;
      DispText(Display,0);
   end;
   Active := False;
end;

Destructor TEdit.Done;
begin
   inherited done;
end;

Constructor TMacEdit.Init(PR : TRect; PCode : integer;
                          PDef, PKeySet : String;
                          PMax : integer);
begin
   inherited init(Pr, PCode, PDef, PKeySet, PMax);
   SamanColor := 10;
   STextC := 0;
end;

Procedure TMacEdit.Draw;
begin
   HideMouse;
   SetDrawViewPort;
   SetColor(0);
   Rectangle(R.X,R.Y,R.X1,R.Y1);
   RestoreDrawViewPort;
   SmnOn := False;
   if S <> '' then
     DispText(Display,0);
   if Active then
     DispSaman(True);
   ShowMouse;
end;

{----------------------------<<<<<< TButton >>>>>>---------------------------}

Procedure TButton.Select;
begin
   if not selected then
   begin
      Selected := True;
      Active := True;
      Draw;
   end;
end;

Procedure TButton.UnSelect;
begin
   if (Selected) or (Active) then
   begin
      Selected := False;
      Active := False;
      Draw;
   end;
end;

Procedure TButton.SetAreas;
begin
   TView.SetAreas;
end;

Constructor TButton.init(PR : TRect; PCode : integer; PName : String; PHKey : KeyType; HKL, Ps : integer);
begin
   TView.Init(Pr,PCode);
   Name := PName;
   Mes := False;
   Selected := False;
   CanBeSelected := True;
   CanBePointed  := True;
   HotKey := PHKey;
   HKLetter := HKL;
   Style := Ps;
end;

Function TButton.CheckMouse : Boolean;
var
 TR : TRect;
begin
   TR := R;
   TR.Move(Owner^.R.x, Owner^.R.y);
   CheckMouse := (TR.ClickedOnMe) and (TR.MouseOnMe);
end;

Function TButton.PressButton : boolean;
var
 TR : TRect;
begin
   TR := R;
   TR.Move(Owner^.R.x, Owner^.R.y);
   mes := true;
   Draw;
   Repeat
     ClearKeyBuff;
     DoSystem;
   until A_mouse.buttonup;
   if TR.MouseOnMe then
    PressButton := True
   else
    PressButton := False;
   mes := False;
   Draw;
end;

Procedure TButton.Draw;
begin
   HideMouse;
   SetDrawViewPort;
   case style of
     1: WButton(r.x,r.y,r.x1,r.y1,HKLetter,name,mes,Selected);
     2: QmButton(r.x,r.y,r.x1,r.y1,HKLetter,name,mes,Selected);
     3: WButton3(r.x,r.y,r.x1,r.y1,HKLetter,name,mes,Selected);
   end;
   RestoreDrawViewPort;
   ShowMouse;
end;

Procedure TButton.Act(var Event : TEvent);
begin
   if Event.What <> evUsrInput then Exit;
   if HotKey.Accepted(Event.T) then
   begin
      Event.What := evCommand;
      Event.Command := Code;
      Mes := true;
      Draw;
      delay(200);
      Mes := false;
      Draw;
      exit;
   end;
   if not Active then
      Exit;
   if Event.T.Me = LButton then
   begin
      if CheckMouse then
      begin
        if PressButton then
        begin
           Event.What := evCommand;
           Event.Command := Code;
        end;
      end;
    end;

   if Event.T.ifkey then
   case Event.T.Key of

      #13 : begin
               Event.What := evCommand;
               Event.Command := Code;
               Mes := true;
               Draw;
               delay(200);
               Mes := false;
               Draw;
            end;

      #32 : begin
               Event.What := evCommand;
               Event.Command := Code;
               Mes := true;
               Draw;
               delay(200);
               Mes := false;
               Draw;
            end;
   end;
end;

Destructor TButton.done;
begin
   inherited done;
end;

Constructor TMacButton.init(PR : TRect; PCode : integer; PName : String; PHKey : KeyType);
begin
   TView.Init(Pr,PCode);
   Name := PName;
   Mes := False;
   Selected := False;
   CanBeSelected := True;
   CanBePointed  := True;
   HotKey := PHKey;
end;


Procedure TMacButton.Draw;
begin
   HideMouse;
   SetDrawViewPort;
   DrawMacButton(r,Name,mes,Selected);
   RestoreDrawViewPort;
   ShowMouse;
end;


{----------------------------<<<<<< TForm >>>>>>---------------------------}

Procedure TForm.OnMove;
begin
   inherited OnMove;
end;

Procedure TForm.SetAreas;
begin
   inherited SetAreas;
end;

Procedure TForm.Select;
begin
   Active := True;
   if ObjCount < 1 then exit;
   if Objects[OnObj]^.CanBeSelected then
   begin
      Objects[OnObj]^.SelectedByKb := False;
      Objects[OnObj]^.Select;
      Objects[OnObj]^.Draw;
   end;
end;

Procedure TForm.UnSelect;
begin
   Active := False;
   if ObjCount < 1 then exit;
   if Objects[OnObj]^.CanBeSelected then
   begin
      Objects[OnObj]^.UnSelect;
      Objects[OnObj]^.Draw;
   end;
end;

Function TForm.MouseOnMe : boolean;
begin
   MouseOnMe := R.MouseOnMe;
end;

Constructor TForm.Init(PR : TRect; PCode : integer;
                       PTitle : String);
var
 i : integer;
begin
   TView.Init(PR, PCode);
   WinTitle := PTitle;
   ObjCount := 0;
   OnObj := 1;
end;

{Procedure TForm.MCursorChange;
var
 i : integer;
begin
   if Not Active then Exit;
 {  SetMC(0);}
 {  for i := 1 to ObjCount do
     Objects[i]^.MCursorChange;
end;}

Procedure TForm.Draw;
var
 i : integer;
begin
   HideMouse;
   TView.Draw;
   for i := 1 to ObjCount do
     Objects[i]^.Draw;
   ShowMouse;
end;

Procedure TForm.DrawTitle(TActive : boolean);
begin
   BWindowTitle(R,WinTitle,TActive);
end;

Procedure TForm.Insert(P : PView);
begin
   if ObjCount < 30 then
   begin
      inc(ObjCount);
      Objects[ObjCount] := P;
      Objects[ObjCount]^.SNum := ObjCount;
      Objects[ObjCount]^.Owner := @Self;
      Objects[ObjCount]^.InitWithOwner;
   end;
end;

Procedure TForm.DoMenu;
begin
end;

Procedure TForm.ChEvUsr(var Event : TEvent);
var
 TR : TRect;
begin
   if Event.T.ifkey then
   begin
      case Event.T.key of
         #9  : begin
                  Event.What    := evObjToObj;
                  Event.Command := cmNext;  {Tab}
               end;

         #15 : if Event.T.c0 then         {Shift-Tab}
               begin
                  Event.What    := evObjToObj;
                  Event.Command := cmPrev;
               end;
      end;
   end;

   if (Event.T.ME = None) then Exit;

   if (TTr.ClickedOnMe) and (TTr.MouseOnMe) then
   begin
      if (ClosB.MouseOnMe) then
      begin
         Event.What := evObjToObj;
         Event.Command := cmCloseButton;
         Exit;
      end;

      Event.What := evSysCommand;
      Event.Command := cmMoveWin;
      Exit;
   end;

   if ObjCount < 1 then exit;

   TR := Objects[OnObj]^.R;
   Objects[OnObj]^.R.Move(R.x,R.y);
   if (not Objects[OnObj]^.R.ClickedOnMe) or
      (not Objects[OnObj]^.CanBePointed) then
   begin
      Event.What := evObjToObj;
      Event.Command := cmOutOfRange;
      Objects[OnObj]^.R := TR;
      Exit;
   end;
   Objects[OnObj]^.R := TR;
end;

Procedure TForm.DoEvUsr(var Event : TEvent);
var
 i    : integer;
 Loop : integer;
 LoopObj : integer;
 LastObj : integer;
 TR : TRect;
begin
   if Event.What <> evObjToObj then Exit;

   case Event.Command of


       cmOutOfRange  : begin
                          DoObj := 0;
                          for i := 1 to ObjCount do
                          begin
                             TR := Objects[i]^.R;
                             Objects[i]^.R.Move(R.x,R.y);
                             if (Objects[i]^.R.MouseOnMe)and
                                (Objects[i]^.R.ClickedOnMe)and
                                (Objects[i]^.CanBePointed)and
                                (I <> OnObj) then
                             begin
                                Objects[i]^.R := TR;
                                if Objects[i]^.CanBeSelected then
                                begin
                                   Objects[OnObj]^.UnSelect;
                                   OnObj := i;
                                   Objects[OnObj]^.Select;
                                   Break;
                                end
                               else
                                begin
                                   Objects[i]^.Select;
                                   DoObj := i;
                                   Break;
                                end;
                             end;
                             Objects[i]^.R := TR;
                          end;
                       end;

       cmCloseButton : begin
                         if ClsBPresd then
                         begin
                            Event.What := evCommand;
                            Event.Command := cmClose;
                            Exit;
                         end;
                       end;

       cmMenuButton  : begin

                       end;

       cmNext        : begin
                          Loop := 0;
                          LastObj := OnObj;
                          Repeat
                             Inc(Loop);
                             if OnObj < ObjCount then
                             Inc(OnObj)
                            else
                             OnObj := 1;
                          Until (Objects[OnObj]^.CanBeSelected)
                                 or (Loop > ObjCount);
                          if Objects[OnObj]^.CanBeSelected then
                          begin
                             Objects[LastObj]^.UnSelect;
                             Objects[OnObj]^.SelectedByKb := True;
                             Objects[OnObj]^.Select;
                          end
                         else
                          OnObj := LastObj;
                          Event.Command := cmNoCommand;
                       end;

       cmPrev        : begin

                          Loop := 0;
                          LastObj := OnObj;
                          Repeat
                             Inc(Loop);
                             if OnObj > 1 then
                             dec(OnObj)
                            else
                             OnObj := ObjCount;
                          Until (Objects[OnObj]^.CanBeSelected)
                                 or (Loop > ObjCount);
                          if Objects[OnObj]^.CanBeSelected then
                          begin
                             Objects[LastObj]^.UnSelect;
                             Objects[OnObj]^.SelectedByKb := True;
                             Objects[OnObj]^.Select;
                          end
                         else
                          OnObj := LastObj;
                          Event.Command := cmNoCommand;
                       end;

       cmSelectObj   : begin
                          for i := 1 to ObjCount do
                          begin
                             if (Event.SenderPtr = Objects[i]) and
                                (OnObj <> I) then
                                begin
                                   Objects[OnObj]^.UnSelect;
                                   OnObj := I;
                                   Objects[OnObj]^.SelectedByKb := True;
                                   Objects[OnObj]^.Select;
                                   Event.SenderPtr := nil;
                                   Event.Command := cmNoCommand;
                                   Event.What := evSysCommand;
                                end;
                          end;
                       end;
   end;
end;

Procedure TForm.Act(var Event : TEvent);
var
 i     : integer;
 sx,sy : integer;
begin
   DoObj := 0;
   case Event.what of

        evUsrInput : begin
                        ChEvUsr(Event);
                        DoEvUsr(Event);
                        if (DoObj <> 0) and (Event.T.ME <> none)then
                        begin
                           Event.What := EvUsrInput;
                           Objects[DoObj]^.Act(Event);
                           Objects[DoObj]^.UnSelect;
                           DoObj := 0;
                        end
                       else
                        if ObjCount > 0 then
                          if Objects[OnObj]^.CanBePointed then
                          begin
                             if Objects[OnObj]^.CanBeSelected then
                               Objects[OnObj]^.Act(Event)
                              else
                               if Event.T.ME <> none then
                                Objects[OnObj]^.Act(Event);
                          end;
                        DoEvUsr(Event);
                     end;
   end;

   if (Event.What = evUsrInput)and(ObjCount>0) then
      begin
        for i := 1 to ObjCount do
         if i <> OnObj then
         begin
           Objects[i]^.Act(Event);
           if Event.What <> evUsrInput then
           begin
             DoEvUsr(Event);
             exit;
           end;
         end;
      end;
   DoEvUsr(Event);
end;

Procedure TForm.Move(x,y : integer);
var
 i : integer;
begin
   TView.Move(x,y);
end;

Procedure TForm.UnClamp;
var
 i : integer;
begin
   TView.UnClamp;
   for i := 1 to ObjCount do
     Objects[i]^.UnClamp;
end;

Function TForm.ClsBPresd : Boolean;
begin
  ClsBPresd := False;
  BWindowControls(R,False,False,True);
  Repeat
    ClearKeyBuff;
    DoSystem;
  until buttonup;
  if ClosB.MouseOnMe then
  ClsBPresd := True
else
  BWindowControls(R,False,False,False);
end;

Function TForm.MaxBPresd : Boolean;
begin
end;

Function TForm.MnuBPresd : Boolean;
begin
end;

Function TForm.MinBPresd : Boolean;
begin
end;

Function TForm.RszBPresd : Boolean;
begin
end;


Procedure TForm.TimeUpDate;
begin
   if ObjCount < 1 then exit;
   if Objects[OnObj]^.CanBeSelected then
     Objects[OnObj]^.TimeUpDate;
end;

Procedure TForm.Clamp(P : TPoint);
var
 i : integer;
begin
   TView.Clamp(P);
   for i := 1 to ObjCount do
     Objects[i]^.Clamp(P);
end;

Destructor TForm.Done;
var
 i : integer;
begin
   inherited done;
   for i := 1 to ObjCount do
     Dispose(Objects[i], Done);
end;

{----------------------------<<<<<< TMacForm >>>>>>--------------------------}

Function TMacForm.ClsBPresd : Boolean;
begin
  ClsBPresd := False;
  M.DrawCtrls(True,False);
  Repeat
    ClearKeyBuff;
    DoSystem;
  until buttonup;
  if ClosB.MouseOnMe then
    ClsBPresd := True
  else
    M.DrawCtrls(False,False);
end;

Function TMacForm.MaxBPresd : Boolean;
begin
  MaxBPresd := False;
  M.DrawTitle(False,True,True);
  Repeat
    ClearKeyBuff;
    DoSystem;
  until buttonup;
  if ClosB.MouseOnMe then
    MaxBPresd := True
  else
    M.DrawTitle(False,False,True);
end;

Procedure TMacForm.Draw;
var
 i : integer;
begin
   M.Draw(Active);
   for i := 1 to ObjCount do
     Objects[i]^.Draw;
end;

Constructor TMacForm.init(PR : TRect; PCode : integer;
                                 PTitle : String);
begin
   M.Init;
   inherited Init(PR,PCode,PTitle);
   SetAreas;
end;

Procedure TMacForm.DrawTitle(TActive : boolean);
begin
   M.DrawTitle(False,False,TActive);
end;

Procedure TMacForm.SetAreas;
begin
   Inherited SetAreas;
   M.Assign(R.x,R.y,R.x1,R.y1,WinTitle);
   M.SetRECTS(TTr,ClosB,MaxB);
end;

Destructor TMacForm.Done;
begin
   Inherited done;
end;

end.
