Unit Telem;

interface

  uses Crt, Dos, Graph, Mouse;

Type
  PValue = ^TValue;
  TValue = Object
              DTime  : Longint;
              Val    : real;
              Active : boolean;
              Constructor Init(DT : longint; v : real; act : boolean);
           end;

  TButton = Object
               x1,y1,x2,y2 : integer;
               Pressed     : boolean;
               Ready       : boolean;
               Ok          : boolean;
               Text        : String;
               Procedure Init(px1,py1,px2,py2 : integer; s : string);
               Procedure UpDate;
               Function MouseOnMe : boolean;
               Procedure Draw;
            end;

  PGraph = ^TGraph;
  TGraph = object
              Name   : String;
              Units  : String;
              Values : Array[1..500] of PValue;
              Count  : integer;
              x1,y1,x2,y2 : integer;
              XCord  : integer;
              DeltaX,
              DeltaY : real;
              MaxTime : real;
              MinTime : real;
              MaxValue : real;
              MinValue : real;
              DeltaTime : real;
              DeltaVal : real;
              Dx : integer;
              Dy : real;
              Ux : integer;
              Uy : real;
              Result : byte;

              _i : real;
              _n : real;
              _x : real;

              ii : real;
              nn : real;
              xx : real;
              Drown : boolean;
              Constructor Init(N, U : string);
              Procedure AddValue(DT : longint; v : real; Act : boolean);
              Procedure GetMaxValue;
              Procedure GetMinValue;
              Procedure GetMaxTime;
              Procedure GetMinTime;
              Procedure GetValuesDelta;
              Procedure CalculateGraph;
              Procedure DrawGraph;
              Procedure TagX(pos : real; Text : boolean);
              Procedure TagY(pos : real; Text : boolean);
              Procedure GetLoc(y,x : real; var sx, sy : integer);
              Procedure DrawIt;
              Procedure Loop;
           end;

 TDataCollector = Object
                      Dir    : String;
                      Graphs : Array[1..300] of PGraph;
                      Count  : integer;
                      Full   : Boolean;
                      Constructor Init(PD : String);
                      Procedure ConvertLine(S : String; var l : longint;
                                            var v : real; var ChN : String);
                      Procedure CreateGraph(var p : PGraph; fn : string);
                      Procedure DisplayGraphs;
                      Procedure FindFiles;
                      Procedure LReset;
                   end;


implementation

Function ClearNum(Num : LongInt) : String;
var
 S : String;
 C, J, I : Byte;
Begin
   Str(Num, S);
   if Length(S) > 3 then
   Begin
      C := 1;
      J := Length(S);
      for I := 1 to Length(S) do
      Begin
         Inc(C);
         J := J -1;
         if (C = 3) and (J > 1) then
         Begin
            Insert(',',S,J);
            C := 0;
         End;
      End;
   End;
   ClearNum := S;
End;

Function Strng(r : real; pos : integer) : string;
var
 s : string;
begin
   Str(r:1:pos,S);
   if system.Pos('.0',s) <> 0 then
     delete(S, Length(s)-1,2);
   Strng := s;
end;

Procedure ConvertTime(var time : longint; var T : DateTime);
var
 l, l2 : longint;
begin
   T.Year := 1998;
   T.Month := 6;
   T.Day := 9;
   T.Hour := 18;
   T.Min := 43;
   T.Sec := 28;
   PackTime(T,l);
   l2 := (time-897417808) div 2;
   l := l + l2;
   UnPackTime(l,t);
end;


Constructor TValue.Init(DT : longint; v : real; act : boolean);
begin
   DTime := DT;
   Val := v;
   Active := Act;
end;

Constructor TGraph.Init(N, U : String);
var
 i : integer;
begin
   for i := 1 to 500 do
     Values[i] := nil;
   Count := 0;
   x1 := 50;
   x2 := 550;
   y1 := 40;
   y2 := 460;
   Name := N;
   Units := U;
   Drown := False;
end;

Procedure TGraph.AddValue(DT : longint; v : real; Act : boolean);
begin
   Inc(Count);
   Values[Count] := New(PValue, Init(DT, v, Act));
end;

Procedure TGraph.GetMaxValue;
var
 i : integer;
 m : real;
begin
   m := 0;
   for i := 1 to count do
    if Values[i]^.Val > m then
      m := Values[i]^.Val;
   MaxValue := m;
end;

Procedure TGraph.GetMinValue;
var
 i : integer;
 m : real;
begin
   m := Values[Count]^.Val;
   for i := 1 to count do
    if Values[i]^.Val < m then
      m := Values[i]^.Val;
   MinValue := m;
end;


Procedure TGraph.GetMaxTime;
var
 i : integer;
 m : longint;
begin
   m := 0;
   for i := 1 to count do
    if Values[i]^.DTime > m then
      m := Values[i]^.DTime;
   MaxTime := m/60;
end;

Procedure TGraph.GetMinTime;
var
 i : integer;
 m : longint;
begin
   m := Values[Count]^.DTime;
   for i := 1 to count do
    if Values[i]^.DTime < m then
      m := Values[i]^.DTime;
   MinTime := m/60;
end;

Procedure TGraph.GetValuesDelta;
begin
   DeltaTime := MaxTime-MinTime;
   if DeltaTime = 0 then
      DeltaTime := 0.1;
   DeltaVal := MaxValue-MinValue;
   if DeltaVal = 0 then
      DeltaVal := 0.1;

end;

Procedure TGraph.CalculateGraph;
begin
   GetMaxTime;
   GetMinTime;
   GetMaxValue;
   GetMinValue;
   GetValuesDelta;

   DeltaY := (y2-y1) / (DeltaVal);
   DeltaX := (x2-x1) / (DeltaTime);
   if MinValue < 0 then
     XCord := Round(DeltaY * (MaxValue))-1
    else
     XCord := Round(DeltaY * (DeltaVal))-1;
   if (MaxValue = MinValue) or
      ((MinValue > 0.01) and (DeltaVal > MinValue)) then
   begin
      AddValue(100,0,False);
      CalculateGraph;
   end;

end;

Procedure TGraph.TagX(pos : real; Text : boolean);
var
 x,y : integer;
begin
   x := x1+round(pos * deltax);
   y := y1+XCord;
   SetColor(15);
   Line(x,y-2,x,y+2);
   if text then
   begin
      SetColor(14);
      Line(x,y-4,x,y+4);
      OutTextXY(x-TextWidth(Strng(pos,1)) div 2,y+6,Strng(pos,1));
   end;
end;

Procedure TGraph.TagY(pos : real; Text : boolean);
var
 x,y : integer;
 s : string;
begin
   x := x1;
   y := y2-round((pos) * deltay);
{   y := (y2-y1)-y;}
   SetColor(15);
   Line(x-2,y,x+2,y);
   if text then
   begin
      SetColor(14);
      Line(x-4,y,x+4,y);
      s := Strng(pos+MinValue,1);
      OutTextXY(x-TextWidth(s)-5,y-3,s);
   end;
end;

Procedure TGraph.GetLoc(y,x : real; var sx, sy : integer);
begin
   sx := x1+Round((y-MinTime)*DeltaX);
   sy := y2-Round((x-MinValue)*DeltaY);
end;

Procedure TGraph.DrawIt;
var
 f: boolean;
 i,x,y: integer;
begin
   f := false;
   SetColor(1);
   SetFillStyle(1,15);
   for i := 1 to Count do
     if Values[i]^.Active then
     begin
        GetLoc(Values[i]^.DTime/60,Values[i]^.Val, x,y);
        if not f then
        begin
           MoveTo(x,y);
           Bar(x-1,y-1,x+1,y+1);
           F := True;
        end
       else
        begin
           LineTo(x,y);
           PutPixel(x,y,0);
           Bar(x-1,y-1,x+1,y+1);
        end;
     end;
end;


Procedure TGraph.DrawGraph;
var
 v,f : real;
begin
   ClearViewPort;
   dx := 60;
   dy := 30;
   Ux := 1;
   Uy := 1;
   if (DeltaVal > 0) and (DeltaVal <= 10) then Uy := 0.5;
   if (DeltaVal > 10) and (DeltaVal <= 20) then Uy := 2;
   if (DeltaVal > 20) and (DeltaVal <= 50) then Uy := 5;
   if (DeltaVal > 50) and (DeltaVal <= 100) then Uy := 10;
   if (DeltaVal > 100) and (DeltaVal <= 1000) then Uy := 50;
   if (DeltaVal > 1000) and (DeltaVal <= 10000) then Uy := 100;

   _n := 0;
   if deltax < Dx then
   begin
      repeat
         _n := _n + Ux;
      until deltax*_n >= Dx;
   end;
   if _n = 0 then _n := 1;

   nn := 0;
   if (deltay < Dy) then
   begin
      repeat
         nn := nn + Uy;
      until (deltay*nn >= Dy);
   end;
   if nn = 0 then nn := 0.5;

   if (MaxValue > 0) and (not Drown) then
   begin
      v := MaxValue;
      if (MaxValue/(nn)) > 0.001 then
         v := (Int(MaxValue/10))*10;
      v := v+nn;
      if v < MaxValue+1 then v := MaxValue+1;
      AddValue(0,v,False);
      CalculateGraph;
   end;

   if (MinValue < 0) and (not Drown) then
   begin
      v := MinValue;
      if (MaxValue/(nn)) > 0.001 then
        v := Int(MinValue/10)*10;
      v := v-(2*nn);
      if v > MinValue-1 then
         v := MinValue-1;
      AddValue(0,v,False);
      CalculateGraph;
   end;

   SetColor(15);
   Line(x1,y1,x1,y2);
   Line(0,y1+XCord,x2,y1+XCord);
   OutTextXY(x2+5,y1+XCord,'Time [MIN]');
   OutTextXY(x1-30,y1-13,Units);
   OutTextXY(x1+((x2-x1) div 2)-((Length(Name)*10) div 2),y1-30,Name);

   _i := 0;
   _x := _n/4;
   if _x <= 0 then _x := 1;
   repeat
      if _n <> 0 then
      begin
         if Frac(_i/_n) < 0.01 then
           TagX(_i, true)
          else
           TagX(_i, false);
      end;
      _i := _i + _x;
   until _i >= DeltaTime;

   ii := 0;
   xx := nn/4;
   if xx <= 0 then xx := 1;
   repeat
      if Frac(ii/nn) < 0.1 then
        TagY(ii, true)
       else
        TagY(ii, false);
      ii := ii + xx;
   until ii > DeltaVal;
   DrawIt;
   Drown := True;
end;

Procedure TButton.Init(px1,py1,px2,py2 : integer; s : string);
begin
   Pressed := False;
   Ok := False;
   Ready := False;
   x1 := px1;
   y1 := py1;
   x2 := px2;
   y2 := py2;
   Text := S;
end;

Procedure TButton.Draw;
begin
   SetColor(15);
   SetFillStyle(1,9);
   Bar(x1,y1,x2,y2);
   Rectangle(x1,y1,x2,y2);
   OutTextXY(x1+((x2-x1) div 2)-((Length(Text)*9) div 2),
             y1+((y2-y1) div 2)-4, Text);
end;

Function TButton.MouseOnMe : boolean;
var
 mx,my : integer;
begin
   mx := GetMouseX;
   my := GetMouseY;
   if (mx >= x1) and (mx <= x2) and
      (my >= y1) and (my <= y2) then
        MouseOnMe := True
       else
        MouseOnMe := False;
end;

Procedure TButton.UpDate;
begin
   if ButtonUp and (MouseOnMe) then Ready := True;
   if not MouseOnMe then Ready := False;
   if ButtonUp and (not MouseOnMe) then
   begin
      Pressed := False;
      Ready := False;
   end;
   if ButtonUp and MouseOnMe and Pressed and Ready then Ok := True;
   if ButtonDown and MouseOnMe and Ready then
      Pressed := True;
end;

Procedure TGraph.Loop;
var
 i, iii   : integer;
 mx,my   : integer;
 x,y     : integer;
 P       : Pointer;
 Size    : Word;
 Buttons : Array[1..4] of TButton;

Function InRange : word;
var
 i      : integer;
begin
   mx := GetMouseX;
   my := GetMouseY;
   InRange := 0;
   for i := 1 to Count do
     if Values[i]^.Active then
     begin
        GetLoc(Values[i]^.DTime/60,Values[i]^.Val,x,y);
        if (mx >= x-3) and (mx <= x+3) and
           (my >= y-3) and (my <= y+3) then
           begin
              InRange := i;
              iii := i;
              break;
           end;
     end;
end;

var
 V : integer;
 tx, ty : integer;
 ch : char;
begin
   ShowMouse;
   SetMouseSensitivity(35,35);
   Result := 0;
   SetColor(15);
   SetFillStyle(1,1);
   Bar(x2+4,y1,GetMaxX,GetMaxY-30);
   Rectangle(x2+4,y1,GetMaxX,GetMaxY-30);
   Buttons[1].Init(x2+10,y1+10,GetMaxX-7,y1+30,'CLOSE');
   Buttons[1].Draw;
   Buttons[2].Init(x2+10,y1+40,GetMaxX-7,y1+60,'PRINT');
   Buttons[2].Draw;
   Buttons[3].Init(x2+10,y1+70,GetMaxX-7,y1+90,'NEXT >>');
   Buttons[3].Draw;
   Buttons[4].Init(x2+10,y1+100,GetMaxX-7,y1+120,'<< PREV');
   Buttons[4].Draw;

   repeat
      v := InRange;
      if v <> 0 then
      begin
         HideMouse;
         if x+100 >= GetMaxX then
            x := x-100;
         if y+60 >= GetMaxY then
            y := y-60;
         Size := ImageSize(x,y,x+100,y+60);
         GetMem(P,Size);
         GetImage(x,y,x+100,y+60,P^);
         SetFillStyle(1,9);
         Bar(x+1,y+1,x+99,y+59);
         SetColor(15);
         Rectangle(x+1,y+1,x+99,y+59);
         OutTextXY(x+14,y+4,'Position:');
         OutTextXY(x+4,y+26,'X: '+Strng(Values[iii]^.DTime/60,1));
         OutTextXY(x+4,y+46,'Y: '+Strng(Values[iii]^.Val,1));
         tx := x;
         ty := y;
         repeat
         until v <> InRange;
         PutImage(tx,ty,P^,0);
         FreeMem(P,Size);
         ShowMouse;
      end;
      for i := 1 to 4 do
        Buttons[i].UpDate;
      for i := 1 to 4 do
        if Buttons[i].Ok then
          Result := I;
      if keypressed then
      begin
         ch := readkey;
         if ch = #27 then
           Result := 1; {CLOSE}
      end;
   until (Result <> 0);
end;


{var
 Gd, Gm : integer;
 P : PGraph;
{Procedure ChDirDialog;
var
 D : YDialog;
begin
   D.Init;
   D.Set_Items_Colors(15,2,14,1);
   D.Add_Item('~O~k','o',10,8,1);
   D.Add_Item('~C~ancel','c',52,8,1);
   D.Add_Sade('~T~elem files dir: ','t',10,5,Dir,30);
   D.InitWindow(' YMS ');
   D.Play;
end;}

Constructor TDataCollector.Init(PD : String);
begin
   Full := False;
   Dir := PD;
end;

Procedure TDataCollector.LReset;
var
 i : integer;
begin
   if not full then exit;
   for i := 1 to Count do
     Dispose(Graphs[i]);
   Count := 0;
end;

Procedure TDataCollector.ConvertLine(S : String; var l : longint; var v : real; var Chn : String);
var
 i : integer;
 words : array[1..20] of string[30];
 wcount : byte;
 space : boolean;
 err : integer;
begin
   Chn := '';
   L := 0;
   v := 0;
   WCount := 0;
   Space := False;
   for i := 1 to 20 do
     Words[i] := '';

   for i := 1 to length(s) do
    if s[i] = ' ' then space := true
   else
    if (space) and (s[i] <> ' ') then
    begin
       space := false;
       Inc(wCount);
       words[wCount] := Words[wCount]+ UpCase(s[i]);
    end
   else
    if (not space) and (s[i] <> ' ') then
    begin
       words[wCount] := Words[wCount]+ UpCase(s[i]);
    end;

   if (Words[1] = 'CHANNEL') and (Words[2] = 'NAME') then
       Chn := Words[4];
   if (Words[1] = 'CHANNEL') and (Words[2] = 'NUMBER') then
      Val(Words[4],V,err);

   if wCount = 2 then
   begin
      Val(Words[1],L,err);
      Val(Words[2],V,err);
   end;
end;

Procedure TDataCollector.DisplayGraphs;
var
 i : integer;
 result : integer;
begin
   if Count < 1 then exit;
   i := 1;
   repeat
      Graphs[i]^.DrawGraph;
      Graphs[i]^.Loop;
      result := Graphs[i]^.Result;
      if (Result = 3) and (I < Count) then
         Inc(I);
      if (Result = 4) and (I > 1) then Dec(I);
   until result = 1;
end;

Procedure TDataCollector.CreateGraph(var p : PGraph; fn : string);
var
 F   : text;
 S   : String;
 L   : longint;
 V   : real;
 Chn : String;
 Ok  : Boolean;
 i   : integer;
 Mv  : Longint;
begin
   P := nil;
   Assign(F, Fn);
   {$I-}ReSet(F);{$I+}
   if IOResult <> 0 then
     Exit;
   Ok := False;
   while not eof(f) do
   begin
      Readln(F,s);
      ConvertLine(S,L,V,Chn);
      if Chn <> '' then
      begin
         P := New(PGraph, Init(Chn, 'Value'));
         Ok := True;
      end;
      if Ok and (L <> 0) and (V <> 0) then
        P^.AddValue(L,V,True);
   end;
   Close(F);
   if (not Ok) or (P^.Count < 1) then
   begin
      P := Nil;
      Exit;
   end;
   P^.GetMinTime;
   MV := Round(P^.MinTime*60);
   for i := 1 to P^.Count do
     P^.Values[i]^.DTime := P^.Values[i]^.DTime - Mv;

   P^.CalculateGraph;
end;

Procedure TDataCollector.FindFiles;
var
 DI : SearchRec;
 d  : string;
 P  : PGraph;
begin
   D := Dir;
   Count := 0;
   if D[Length(d)] = '\' then
      Delete(D,Length(d),1);
   FindFirst(D+'\*.txt', anyfile, DI);
   While doserror = 0 do
   begin
      CreateGraph(P, D+'\'+DI.Name);
      if P <> nil then
      begin
         Inc(Count);
         Graphs[Count] := P;
      end;
      FindNext(DI);
   end;
   Full := True;
end;

begin
{   initgraph(Gd, Gm ,'');
   P := New(PGraph, Init('MyGraph!','[Units]'));
   P^.AddValue(10,0, True);
   P^.AddValue(1000,201, True);
   P^.AddValue(2000,302, True);
   P^.AddValue(3000,300, True);
   P^.AddValue(4000,504, True);
   P^.AddValue(5000,605, True);
   P^.CalculateGraph;
   P^.DrawGraph;
   P^.Loop;}
end.